
	opt	noidw
	section sEc709fadd

fadd_ba
	global fadd_ba
 
	move	r2,y:(r6)+
	move	n2,y:(r6)+
	move	x0,y:(r6)+
	move	x1,y:(r6)+
	move	y0,y:(r6)+
	move	y1,y:(r6)+
	move	b0,y:(r6)+
	move	b1,y:(r6)

   ; initialize shift table pointer
	move	#F__fp_shift,n2	

   ; shuffle arguments
	move	b1,x1
	move	b0,x0
	move	a0,b
	move	a1,a

   ;
   ; actually begin fadd
   ;
	cmp     x0,b	#>23,y0		; delta = er - ea, get delta limit
        bge     <dposA_ba		; jump if er >= ea

	tfr     x1,a    a1,x1           ; swap ma with mr
        tfr     x0,b    b1,x0           ; swap ea with er

dposA_ba
	sub     x0,b    b1,y1           ; calculate delta, save er'
        cmp     y0,b    b1,r2           ; check delta limit, save delta
        bge     <done1_ba		; jump if delta >= 23

	move    y:(r2+n2),x0     	; lookup shift constant s
        mac     -x1,x0,a        y1,r2   ; denormalize by s,add mantissa,get er'
	move    #$0,a0			; clear any mac junk, for norm of 0.0 
        bra     <norm1_ba		; try for quick normalization


;
; norm and round result - assumes a=mr', r2=er' and CCR reflects mr' value.
;

norm_ba
	do	#8,L1			; normalize up to 8 bits left or right
norm1_ba
        norm    r2,a                    ; shift 1 bit and update exponent by 1
L1
        bnn     <norm_ba			; jump if not normalized
        rnd     a                       ; round to 24 bit mr
        norm    r2,a                    ; correct mr overflow due to round

;
; detect and correct exceptions - assumes a=mr and r2=er
;

        btst    #15,r2
        bcs     <under_ba		; jump if exponent underflow
        btst    #14,r2
        bcs     <limit_ba		; jump if exponent overflow

	tst     a       r2,b            ; check mr, get er
        teq     a,b			; if mr=0, correct to fp zero
	move	b1,a0

	bra	<done_ba

under_ba
	or      #$40,ccr                ; set L=1 for exponent underflow
	clr     a			; correct to fp zero
	bra	<done_ba

limit_ba
	asl     a       #$003fff,y1     ; correct to maximum fp value
done1_ba

   ; At this point, A1 == RESULT MANTISSA
   ;                Y1 == RESULT EXPONENT

   ; set for A10 return
	move	a1,a
	move	y1,a0

done_ba
	move	y:(r6)-,b		;
	move	y:(r6)-,b0		;
	move	y:(r6)-,y1		;
	move	y:(r6)-,y0		;
	move	y:(r6)-,x1		;
	move	y:(r6)-,x0		;
	move	y:(r6)-,n2		;
	tst	a	y:(r6),r2	;
	rts

	endsec
