
	opt	noidw
	section sEc709fneg

fneg_b
	global fneg_b

   ;   save registers
	move	r2,x:(r6)+
	move	y1,x:(r6)+
	move	a0,x:(r6)+
	move	a1,x:(r6)

   ; begin fneg
	move	b0,r2			; save exponent
	move	b1,b			; A contains ONLY mantissa

	neg	b			; negate ma, save ea
	jmp	norm1_b

; normalize and round result - assumes a=mr', r2=er' and CCR reflects mr' value.

norm_b
	do	#8,LL2			; normalize up to 8 bits left or right
norm1_b
	norm    r2,b                    ; shift 1 bit and update exponent by 1
LL2
        jnn     norm_b			; jump if not normalized
	rnd     b                       ; round to 24 bit mr
        norm    r2,b                    ; correct mr overflow due to round

; detect and correct exceptions - assumes a=mr and r2=er
	btst	#15,r2
	bcs	<under_b		; jump if exponent underflow
	btst	#14,r2
	bcs	<limit_b		; jump if exponent overflow

	tst     b       r2,a            ; check mr, get er
        teq     b,a			; if mr=0, correct to fp zero
	move	a1,b0

	bra	<done_b

under_b
	or      #$40,ccr                ; set L=1 for exponent underflow
zero_b
	clr     b       #0,a            ; correct to fp zero
	bra	<done_b

limit_b
	asl     b       #$003fff,y1     ; correct to maximum fp value
done1_b
	tfr     y1,a    b,b             ; get mr and er, set L bit if mr limited
	move    a1,b0			; format for compiler storage

   ;   restore registers
done_b
	move	x:(r6)-,a		;
	move	x:(r6)-,a0		;
	move	x:(r6)-,y1		;
	tst	b	x:(r6),r2	;
	rts

	endsec
