
	opt	noidw
	section sEc709fsub

fsub_ab
	global fsub_ab

   ;   save registers
	move	r2,x:(r6)+
	move	n2,x:(r6)+
	move	x0,x:(r6)+
	move	x1,x:(r6)+
	move	y0,x:(r6)+
	move	y1,x:(r6)+
	move	a0,x:(r6)+
	move	a1,x:(r6)

   ;   initialize shift table pointer
	move	#F__fp_shift,n2	

   ;   shuffle arguments
	move	a1,x1
	move	a0,x0
	move	b1,a
	move	b0,b

   ;   begin fsub
	sub     x0,b    b1,y1           ; compare delta = ea - ex, save ea
        bge     dposS_ab		; jump if ea >= ex

; ea < ex
	tfr     x1,a    a1,x1           ; swap ma with mx
        neg     a       x0,y1           ; negate mx, save ex
        abs     b       #>23,y0         ; negate er', get delta limit
        cmp     y0,b    b1,r2           ; check delta limit, save delta
        ble     addm_ab			; jump if delta =< 23
        tst     a       x0,r2           ; get er', setup CCR for norm
        bra     norm1_ab		; normalize result

; ea >= ex
dposS_ab
	move    #>23,y0			; get delta limit
        cmp     y0,b    b1,r2           ; check delta limit, save delta
        bge     done1_ab		; jump if delta >= 23
        move    x:(r2+n2),x0     	; lookup shift constant s
        mac     x1,x0,a y1,r2           ; denormalize by s, sub mant, get er'
	move    #$0,a0			; clear any mac junk, for norm of 0.0
        bra     norm1_ab		; try for quick normalization

addm_ab
	move    x:(r2+n2),x0            ; lookup shift constant s
	mac     -x1,x0,a        y1,r2   ; denormalize by s,add mantissa,get er'
	move    #$0,a0                  ; clear any mac junk, for norm of 0.0 
	bra     norm1_ab		; try for quick normalization

; normalize and round result - assumes a=mr', r2=er' and CCR reflects mr' value.
norm_ab
	dor	#8,LL2			; normalize up to 8 bits left or right
norm1_ab
	norm    r2,a                    ; shift 1 bit and update exponent by 1
LL2
        bnn     norm_ab			; jump if not normalized
	rnd     a                       ; round to 24 bit mr
        norm    r2,a                    ; correct mr overflow due to round

; detect and correct exceptions - assumes a=mr and r2=er
	btst	#15,r2
	bcs	under_ab		; jump if exponent underflow
	btst	#14,r2
	bcs	limit_ab		; jump if exponent overflow

	tst     a       r2,b            ; check mr, get er
        teq     a,b			; if mr=0, correct to fp zero
	move	b1,a0
	bra	done_ab

under_ab
	or      #$40,ccr                ; set L=1 for exponent underflow
	clr     a       #0,b            ; correct to fp zero
	bra	done_ab

limit_ab
	asl     a       #>$3fff,y1     ; correct to maximum fp value
done1_ab
	tfr     y1,b    a,a             ; get mr and er, set L bit if mr limited
	move    b1,a0			; format for compiler storage

   ;   restore registers
done_ab
	tfr	a,b	x:(r6)-,a
	move	x:(r6)-,a0		;
	move	x:(r6)-,y1		;
	move	x:(r6)-,y0		;
	move	x:(r6)-,x1		;
	move	x:(r6)-,x0		;
	move	x:(r6)-,n2		;
	tst	b	x:(r6),r2	;
	rts

	endsec

