
	opt	noidw
	section sEc709fadd

fadd_ab
	global fadd_ab
 
   ; save resources
	move	r2,y:(r6)+	; used to get shift values
	move	n2,y:(r6)+	;
	move	x0,y:(r6)+
	move	x1,y:(r6)+
	move	y0,y:(r6)+
	move	y1,y:(r6)+
	move	a0,y:(r6)+
	move	a1,y:(r6)

   ; initialize shift table pointer
	move	#F__fp_shift,n2	

   ; shuffle arguments
	move	a1,x1
	move	a0,x0
	move	b1,a
	move	b0,b

   ;
   ; actually begin fadd
   ;
	cmp     x0,b	#>23,y0		; delta = er - ea, get delta limit
        bge     <dposA_ab		; jump if er >= ea

	tfr     x1,a    a1,x1           ; swap ma with mr
        tfr     x0,b    b1,x0           ; swap ea with er

dposA_ab
	sub     x0,b    b1,y1           ; calculate delta, save er'
        cmp     y0,b    b1,r2           ; check delta limit, save delta
        bge     <done1_ab		; jump if delta >= 23

	move    y:(r2+n2),x0     	; lookup shift constant s
        mac     -x1,x0,a        y1,r2   ; denormalize by s,add mantissa,get er'
	move    #$0,a0			; clear any mac junk, for norm of 0.0 
        bra     <norm1_ab		; try for quick normalization


;
; norm and round result - assumes a=mr', r2=er' and CCR reflects mr' value.
;

norm_ab
	do	#8,L2			; normalize up to 8 bits left or right
norm1_ab
        norm    r2,a                    ; shift 1 bit and update exponent by 1
L2
        bnn     <norm_ab		; jump if not normalized
        rnd     a                       ; round to 24 bit mr
        norm    r2,a                    ; correct mr overflow due to round

;
; detect and correct exceptions - assumes a=mr and r2=er
;

        btst    #15,r2
        bcs     <under_ab		; jump if exponent underflow
        btst    #14,r2
        bcs     <limit_ab		; jump if exponent overflow

	tst     a       r2,b            ; check mr, get er
        teq     a,b			; if mr=0, correct to fp zero
	move	b1,a0
	tfr	a,b			; new return register

	bra	<done_ab

under_ab
	or      #$40,ccr                ; set L=1 for exponent underflow
	clr     b			; correct to fp zero
	bra	<done_ab

limit_ab
	asl     a       #$003fff,y1     ; correct to maximum fp value
done1_ab

   ; At this point, A1 == RESULT MANTISSA
   ;                Y1 == RESULT EXPONENT

   ; set for B10 return
	move	a1,b
	move	y1,b0

   ;
   ;   restore registers
   ;
done_ab
	move	y:(r6)-,a		;
	move	y:(r6)-,a0		;
	move	y:(r6)-,y1		;
	move	y:(r6)-,y0		;
	move	y:(r6)-,x1		;
	move	y:(r6)-,x0		;
	move	y:(r6)-,n2		;
	tst	b	y:(r6),r2	;
	rts

	endsec
