
	opt	noidw
	section sEc709fdiv

fdiv_ab
	global fdiv_ab

   ;   save registers
	move	r2,y:(r6)+
	move	x0,y:(r6)+
	move	x1,y:(r6)+
	move	y0,y:(r6)+
	move	y1,y:(r6)+
	move	a0,y:(r6)+
	move	a1,y:(r6)

   ; shuffle arguments
        move    a0,x0
        move    a1,x1
        move    b1,a
        move    b0,b

   ; actually begin fdiv
	sub     x0,b    #>$1fff,x0      ; calculate er' = ea - ex,get ebias
        add     x0,b                    ; add ebias to er'
        tfr     x1,b    b,r2            ; get mx, save er'
        tst     b                       ; check for divisor mx = 0
        bne     <div1_ab		; jump if divisor not zero
        tst     a                       ; check for dividend ma = 0
        bne     <limit_ab		; jump if dividend not zero
        or      #$40,ccr                ; set L=1 for divide by zero error
div1_ab
	asr     a       a,b             ; force fractional quotient, copy ma
        beq     <done_ab		; jump if dividend ma = 0 (underflow)
        abs     a       (r2)+           ; make dividend positive, adjust er'
        eor     x1,b                    ; calculate quotient sign
        and     #$fe,ccr                ; clear carry (quotient sign bit)
        dor	#24,LL3			; repeat for 24 bit quotient
        div     x1,a                    ; generate one quotient bit
LL3
        bpl     <qpos_ab		; jump if positive quotient
        neg     a                       ; negate mr' for negative quotient
qpos_ab
	move    a0,a                    ; get quotient mr'
        tst     a                       ; normalize mr' 1 extra bit
        norm    r2,a                    ; shift 1 bit and update exponent by 1
        bra     <norm1_ab		; normalize and check for errors


;
; normalize and round result - assumes a=mr', r2=er' and CCR reflects mr' value.
;

norm_ab
	dor	#8,L4			; normalize up to 8 bits left or right
norm1_ab
	norm    r2,a                    ; shift 1 bit and update exponent by 1
L4
	bnn     <norm_ab		; jump if not normalized
	rnd     a                       ; round to 24 bit mr
        norm    r2,a                    ; correct mr overflow due to round

;
; detect and correct exceptions - assumes a=mr and r2=er
;

	btst	#15,r2
	bcs	<under_ab		; jump if exponent underflow
	btst	#14,r2
	bcs	<limit_ab		; jump if exponent overflow

	tst     a       r2,b            ; check mr, get er
        teq     a,b			; if mr=0, correct to fp zero
	move	b1,a0

	bra	<done_ab

under_ab
	or      #$40,ccr                ; set L=1 for exponent underflow
	clr     a       #0,b            ; correct to fp zero
	bra	<done_ab

limit_ab
	asl     a       #$003fff,y1     ; correct to maximum fp value
	tfr     y1,b    a,a             ; get mr and er, set L bit if mr limited
	move    b1,a0			; format for compiler storage

;   restore registers
done_ab

   ; MUST return in B10
	tfr	a,b	y:(r6)-,a	;
	move	y:(r6)-,a0		;
	move	y:(r6)-,y1		;
	move	y:(r6)-,y0		;
	move	y:(r6)-,x1		;
	move	y:(r6)-,x0		;

	tst	b	y:(r6),r2	;
	rts

	endsec
