
	opt	noidw
	section sEc709fneg

fneg_a
	global fneg_a

   ;   save registers
	move	r2,y:(r6)+
	move	y1,y:(r6)+
	move	b0,y:(r6)+
	move	b1,y:(r6)

   ; begin fneg
	move	a0,r2			; save exponent
	move	a1,a			; A contains ONLY mantissa

	neg	a			; negate ma, save ea
	jmp	norm1_a

; normalize and round result - assumes a=mr', r2=er' and CCR reflects mr' value.

norm_a
	do	#8,LL1			; normalize up to 8 bits left or right
norm1_a
	norm    r2,a                    ; shift 1 bit and update exponent by 1
LL1
        jnn     norm_a			; jump if not normalized
	rnd     a                       ; round to 24 bit mr
        norm    r2,a                    ; correct mr overflow due to round

; detect and correct exceptions - assumes a=mr and r2=er
	btst	#15,r2
	bcs	<under_a		; jump if exponent underflow
	btst	#14,r2
	bcs	<limit_a		; jump if exponent overflow

	tst     a       r2,b            ; check mr, get er
        teq     a,b			; if mr=0, correct to fp zero
	move	b1,a0

	bra	<done_a

under_a
	or      #$40,ccr                ; set L=1 for exponent underflow
zero_a
	clr     a       #0,b            ; correct to fp zero
	bra	<done_a

limit_a
	asl     a       #$003fff,y1     ; correct to maximum fp value
done1_a
	tfr     y1,b    a,a             ; get mr and er, set L bit if mr limited
	move    b1,a0			; format for compiler storage

   ;   restore registers
done_a
	move	y:(r6)-,b		;
	move	y:(r6)-,b0		;
	move	y:(r6)-,y1		;
	tst	a	y:(r6),r2	;
	rts

	endsec
