/* Copyright (C) 1990, 1995, by Motorola, Inc. */

#include <errno.h>
#include <math.h>

#undef atan2

double
atan2 ( double y, double x )
{
    double y2, at;
    int neg_y = 0;
    
    if (( 0.0 == x ) && ( 0.0 == y ))
    {
	errno = EDOM;
	
	return 0.0;
    }
    
    if ( 0.0 > y )
    {
	y2 = -y;
	neg_y = 1;
    }
    else
    {
	y2 = y;
    }
    
    if (( y2 - ( 0.0 > x ? -x : x )) == y2 )
    {
	return ( neg_y ? -1.57079632679489661923 : 1.57079632679489661923 );
    }
    
    at = atan ( y / x );
    
    if ( 0.0 < x )
    {
	return at;
    }
    
    if ( neg_y )
    {
	return ( at - 3.14159265358979323846 );
    }
    else
    {
	return ( at + 3.14159265358979323846 );
    }
}
