/* Copyright (C) 1995, by Motorola, Inc. */

# include <errno.h>

extern char* __break;
extern char* __mem_limit;
extern unsigned int __stack_safety;
extern int errno;


#if defined( __DSP561C__ )

static __inline__ char*
get_stack_pointer ( )
{
    char *Rval;

    __asm__ ( "move	r2,%0" : "=D" ( Rval ));

    return ( Rval );
}

#elif defined( __DSP56K__ ) || defined( __DSP563C__ ) || defined( __DSP566C__ )

static __inline__ char*
get_stack_pointer ( )
{
    char *Rval;

    __asm__ ( "move	r6,%0" : "=D" ( Rval ));

    return ( Rval );
}

#else

static __inline__ char*
get_stack_pointer ( )
{
    char *Rval;

    __asm__ ( "move	r6,%z0" : "=r" ( Rval ));

    return ( Rval );
}
#endif


int
brk ( void* addr )
{
    char* compare = (char*) addr;
    char* stp = get_stack_pointer ( ); /* Current Stack Pointer */
    
    if (( compare > __mem_limit ) || 
	( compare < ( stp + __stack_safety )))
    {
	errno = ENOMEM;
	return -1;
    }
    __break = addr;
    return 0;
}


void*
sbrk ( unsigned int delta )
{
    if (delta > ((unsigned int) __break))
        return (void*) -1;
    else
        if ( -1 == brk((void*)(((char*) __break ) - delta )))
            return (void*) -1;
        else
            return __break;
}
