/* Copyright (C) 1995, by Motorola, Inc. */

/*
 * Binary search algorithm, generalized from Knuth (6.2.1) Algorithm B.
 *
 */

char*
bsearch( char* key, char* base, unsigned nel, unsigned width, int (*compar)() )
{
   int two_width;
   char*  last;

   two_width = width << 1;

   /* Last element in table */
   last      = base + width * ( nel - 1 );


   while ( last >= base )
   {
      char* p;
      int   res;

      p = base + width * ((last - base)/two_width);
      res = (*compar)(key, p);

      if ( res == 0 )
      {
	 /* Key found */
         return ( p );
      }


      if ( res < 0 )
      {
         last = p - width;
      }

      else
      {
         base = p + width;
      }
   }


   /* Key not found */
   return ( (char*) 0 );
}
