/* Copyright (C) 1990, 1995, by Motorola, Inc. */

/* we implement the functions specified in ctype.h */

#include <ctype.h>

#undef isalnum

int isalnum ( int c )
{
    return ( isalpha ( c ) || isdigit ( c ));
}

#undef isalpha

int isalpha ( int c )
{
    return ( isupper ( c ) || islower ( c ));
}

#undef iscntrl

int iscntrl ( int c )
{
#if defined( __DSP561C__ ) || defined( __DSP566C__ )
    return ( 0 == ( 0xffe0 & c ) || 0x7f == c );
#elif defined( __DSP56K__ ) || defined( __DSP563C__ )
    return ( 0 == ( 0xffffe0 & c ) || 0x7f == c );
#else
    return ( 0 == ( 0xffffffe0 & c ) || 0x7f == c );
#endif
}

#undef isdigit

int isdigit ( int c )
{
    return ( 0x2f < c && 0x3a > c );
}

#undef isgraph

int isgraph ( int c )
{
    return ( 0x20 < c && 0x7f > c );
}

#undef islower

int islower ( int c )
{
    return ( 0x60 < c && 0x7b > c );
}

#undef isprint

int isprint ( int c )
{
    return ( 0x1f < c && 0x7f > c );
}

#undef ispunct

int ispunct ( int c )
{
    return ( isgraph ( c ) && ! isalnum ( c ));
}

#undef isspace

int isspace ( int c )
{
    switch ( (char) c )
    {
    case ' ':
    case '\f':
    case '\n':
    case '\r':
    case '\t':
    case '\v':
	return 1;
    }
    return 0;
}

#undef isupper

int isupper ( int c )
{
    return ( 0x40 < c && 0x5b > c );
}

#undef isxdigit

int isxdigit ( int c )
{
    return ( isdigit ( c ) || ( 0x40 < c && 0x47 > c ) ||
	    ( 0x60 < c && 0x67 > c ));
}

#undef tolower

int tolower ( int c )
{
    return ( isupper ( c ) ? c + 0x20 : c );
}

#undef toupper

int toupper ( int c )
{
    return ( islower ( c ) ? c - 0x20 : c );
}
