/* Copyright (C) 1990, 1991, 1992, 1995 Motorola, Inc. */

#include <stdlib.h>
#include <stdio.h>

/* externally declared global variables */
extern FILE* __open_files[];

/* ANSI requires the user to have 32 entries, and we need one for 
   stdio buffer cleanup. */
#define MAX_EXIT_FUNCTIONS 32 + 1

void ( * __exit_function_registry[ MAX_EXIT_FUNCTIONS ] ) ( void );
int __functions_registered = 0;
    
/*
  void exit( int status ):

  By ANSI definition, the following tasks are to be performed in order.

      1. All functions registered by "atexit()" are called in REVERSE order
         of their registration.

      2. Flush all unwritten buffered streams.

      3. Close all open streams.
 */

void
exit ( int status )
{
    /* handle any "atexit()" actions */
    __functions_registered -- ;              /* "pop" the stack */
    
    while ( 0 <= __functions_registered )
    {
	( * __exit_function_registry[ __functions_registered -- ] ) ( );
    }

    /* THIS DOES NOT RETURN, The call to "__crt0_end" places us past
       code in the crt0 for making an implicit call to EXIT. */
    __crt0_end ( );
}

