/* Copyright (C) 1995, Motorola, Inc. */

#include <stdio.h>

/*
 * FGETPOS( ):
 *
 * NOTES:
 *    o fpos_t == long
 *    o Maybe in the future, if fpos_t becomes different than long, fgetpos() will
 *      differ from ftell().
 *
 * function return value:
 *
 * ERRNO:
 *    set by ftell( ).
 */

int
fgetpos( FILE* stream, fpos_t* pos )
{
    if ( ( *pos = (fpos_t) ftell( stream ) ) == -1L )
    {
	/* ftell( ) error */
	return 1;
    }
    
    /* successful fseek( ) */
    return 0;
}
