/* Copyright (C) 1995, Motorola, Inc. */

/*
 *	fmod(x, y) returns the remainder of x on division by y,
 *	with the same sign as x,
 *	except that if |y| << |x|, it returns 0.
 */

#include <math.h>

#undef fmod

double
fmod(double x, double y)
{
    double d;

      /*
	The next lines determine if |y| is negligible compared to |x|,
	without dividing, and without adding values of the same sign.
      */

    d = fabs(x);
    
    if ( d - fabs(y) == d )
    {
	return 0.0;
    }
    
    (void) modf( x/y, &d );
    
    return ( x - ( d * y ) );
}
