/* Copyright (C) 1995, Motorola, Inc. */

#include <stdio.h>

/*
 * FPUTS():
 *    The goal here is to write 
 *
 *    Return value:
 *
 *    ERRNO:
 *        unused.
 */

int
fputs( const char *s, FILE *stream )
{
    size_t nmemb, written;
    
    nmemb = strlen( s );
    
    if ( fwrite( s, sizeof(char), nmemb, stream ) != nmemb )
    {
	/* write error has occured */
	stream->_flag |= _IOERR;
	return  EOF;
    }

    /* make sure that we don't return EOF. */
    return nmemb;
}
