/* Copyright (C) 1995, Motorola, Inc. */

#include <stdio.h>
#include <errno.h>


/*
 * FSETPOS( ):
 *
 * NOTES:
 *    o fpos_t == long
 *    o Maybe in the future, if fpos_t becomes different than long, fsetpos() will
 *      differ from fseek().
 *
 * function return value:
 *
 * ERRNO:
 *
 */

int
fsetpos( FILE* stream, const fpos_t* pos )
{
    int retval;
    
    if ( ( retval = fseek( stream, (long) *pos, SEEK_SET ) ) != 0 )
    {
	errno = ESETPOS;
    }

    return retval;
}
