/* Copyright (C) 1995, Motorola, Inc. */

#include <stdio.h>
#include <errno.h>

/* external function declarations */
extern long __lseek( int, long, int );

long
ftell( FILE* stream )
{
    int  diff;
    long retval;
    
    /* is this really an open stream? */
    if ( 0 > stream->_file )
    {
	errno = EINVAL;
	
	return -1L;
    }
    
    /* flush write buffers first, thanks to the IBMPC text mode */
    if ( ( stream->_flag & _IOWRITE ) && !( stream->_flag & _IONBF ) )
    {
	if ( EOF == fflush( stream ) )
	{
	    return( -1L );
	}
    }

    /* current file position */
    if (( retval = (long) __lseek( stream->_file, 0L, __L_INCR )) < 0 )
    {
	/* __lseek( ) error */
	return -1L;
    }

    /* REMEMBER: _IOWRITE streams add to the position */

    /* when stream last used as a _IOREAD stream */
    if ( stream->_flag & _IOREAD )
    {
	diff = - stream->_cnt;
    }
    else
    {
	diff = 0;
    }
    
    /* successful fseek( ) */
    return( retval + (long) diff );
}
