/* Copyright (C) 1995, Motorola, Inc. */
#if defined( __DSP56K__ ) || defined( __DSP563C__ )

#include <math.h>
#include <float.h>
#include <errno.h>

double
ldexp( double dval, int exp )
{
    int dval_exponent, biased_exp;

    if (dval == 0.0)
	return 0.0;

    __asm volatile ( "move %h1,%0" : "=S" (dval_exponent) : "D" (dval) );

    exp += dval_exponent;

    /* make sure new exponent is in range */
    biased_exp = exp - 8191;

    if ( DBL_MAX_EXP < biased_exp || DBL_MIN_EXP > biased_exp )
    {
	errno = ERANGE;
	return HUGE_VAL;
    }

    else
    {
	__asm volatile ( "move %2,%h0": "=D" (dval) : "0" (dval), "D" (exp) );
	return dval;
    }
}

#endif
