/* Copyright (C) 1990, 1995, by Motorola, Inc. */

#include <stdlib.h>

#undef mbstowcs

size_t
mbstowcs ( wchar_t* pwcs, const char* s, size_t n )
{
    size_t converted;
    int i, w_elements_changed = 0;
    
    for ( i = 0; i < n ; i ++ )
    {
	/* check for invalid character */
	if ( ( converted = mbtowc( pwcs, s, MB_CUR_MAX ) ) == -1 )
	{
	    return ( (size_t) -1 );
	}
	
	/* check for NULL termination character */
	if ( converted < MB_CUR_MAX )
	{
	    if ( converted != 0 )
	    {
		w_elements_changed ++ ;
	    }
	    
	    break;
	}
	
	/* bump pwcs and s */
	w_elements_changed ++ ;
	pwcs ++ ;
	s += converted;
    }
    if ( w_elements_changed < n )
    {
	* ( ++ pwcs ) = (wchar_t) 0L;
    }
    
    return ( w_elements_changed );
}

