/* Copyright (C) 1990, 1995, by Motorola, Inc. */

#include <stdlib.h>

#undef mbtowc

int
mbtowc ( wchar_t* pwc, const char* s, size_t n )
{
    wchar_t scratch;
    int chars_shifted_in;
    
    /* no multi character "string" to convert or no conversion asked for */
    if ( NULL == s || 0 == n )
    {
	return 0;
    }

    /* 8 significant bits of our 32-bit character */
    scratch = (*s++) & 0xFF;
    chars_shifted_in = 1;

    while ( (MB_CUR_MAX > chars_shifted_in) && (0 != --n) && (*s != '\0') )
    {
	scratch <<= 8;
	scratch |= (*s++) & 0xFF;
	chars_shifted_in ++ ;
    }
    
    if ( NULL != pwc )
    {
	/* return packed character */
	*pwc = scratch;
    }
        
    return( chars_shifted_in );
}

