/* Copyright (C) 1995, by Motorola, Inc. */

#include <stdlib.h>
#include <stddef.h>

#undef memmove

void*
memmove ( void* s1, const void* s2, size_t n )
{
   char *c_s1, *c_s2 = (char*) s2, *tmp;
   size_t count = n;
   
   /* this could be improved for the no overlap case. */

   if ( ! n )
   {
       return s1;
   }
   
   tmp = (char*) malloc ( n );
   c_s1 = tmp;
   while ( n-- > 0 )
   {
      *c_s1++ = *c_s2++;
   }

   n = count;
   c_s1 = (char*) s1;
   c_s2 = tmp;
   
   while ( n-- > 0 )
   {
      *c_s1++ = *c_s2++;
   }

   free ( tmp );
   
   return ( s1 );
}
