/* Copyright (C) 1995, by Motorola, Inc. */

#include <stdio.h>

/*
 * PUTS():
 *    The goal here is to write 
 *
 *    Return value:
 *
 *    ERRNO:
 *        unused.
 */

int
puts( const char *s )
{
    size_t length;
    FILE*  stream = stdout;
    int    to_write;
    extern int __already_registered_p;
    void __stdio_cleanup ( );
    
    /* ensure that all buffers will eventually be flushed. */
    if ( ! __already_registered_p )
    {
	atexit ( __stdio_cleanup );
	__already_registered_p = 1;
    }

    /* check for the basic errors */
    if ( !(stream->_flag & _IOWRITE ) || stream->_flag & _IOEOF )
    {
	stream->_flag |= _IOERR;
	return  EOF;
    }
    
    /* length of string to add to buffer */
    length = strlen( s );
    
    /* will it fit into current buffer? (don't forget '\n') */
    if ( (length + 1) <= stream->_cnt )
    {
	/* jam it in the buffer */
	memcpy( stream->_ptr, s, length );
	stream->_ptr += length;
	*stream->_ptr++ = '\n';
	stream->_cnt -= (length + 1);

	/* we know for sure that the buffer needs to be written */
	to_write = stream->_bufsiz - stream->_cnt;
	if ( __write( stream->_file, stream->_buffer, to_write ) != to_write )
	{
	    stream->_flag |= _IOERR;
	    return EOF;
	}

	/* Clear stream */
	stream->_cnt = stream->_bufsiz;
	stream->_ptr = stream->_buffer;
	stream->_flag &= ~(_IOEOF | _IOERR);

	/* non-zero for success */
	return 1;
    }
    
    /* new stuff will not fit into buffer, so just write buffer out */
    to_write = stream->_bufsiz - stream->_cnt;
    if ( __write( stream->_file, stream->_buffer, to_write ) != to_write )
    {
	stream->_flag |= _IOERR;
	return EOF;
    }

    /* Clear stream */
    stream->_cnt = stream->_bufsiz;
    stream->_ptr = stream->_buffer;
    stream->_flag &= ~(_IOEOF | _IOERR);

    /* will new stuff fit into a clean buffer? */
    if ( (length + 1) <= stream->_bufsiz )
    {
	/* jam it in the buffer */
	memcpy( stream->_buffer, s, length );

	/* add '\n' */
	length ++ ;   /* string "s" + '\n' */
	*(stream->_buffer + length) = '\n';

	/* write the buffer */
	if ( __write( stream->_file, stream->_buffer, length ) != length )
	{
	    stream->_flag |= _IOERR;
	    return EOF;
	}

	/* non-zero for success */
	return 1;
    }

    /* new stuff overflows buffer -- write out string "s" */
    if ( __write( stream->_file, s, length ) != length )
    {
	stream->_flag |= _IOERR;
	return EOF;
    }

    /* write the '\n' */
    {
	char klien_buf[ ] = "\n";

	if ( __write( stream->_file, klien_buf, 1 ) != 1 )
	{
	    stream->_flag |= _IOERR;
	    return EOF;
	}
    }
	
    /* non-zero for success */
    return 1;
}
