/* Copyright (C) 1995, by Motorola, Inc. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MINCPY	24
#define CPY(i, j) ((void) memcpy(i, j, n))

static char *qsbuf = NULL;

static 	qses, (*qscmp)();

static void
qsexc(char* ri, char* rj)
{
    int n = qses;

    if (n >= MINCPY && qsbuf != NULL)
    {
	CPY(qsbuf, ri);
	CPY(ri, rj);
	CPY(rj, qsbuf);

	return;
    }

    do
    {
	char c = *ri;
	*ri++ = *rj;
	*rj++ = c;
    } while(--n);
}


static void
qstexc(char* ri, char* rj, char* rk)
{
    int n = qses;


    if (n >= MINCPY && qsbuf != NULL)
    {
	CPY(qsbuf, ri);
	CPY(ri, rk);
	CPY(rk, rj);
	CPY(rj, qsbuf);

	return;
    }

    do
    {
	char c = *ri;
	*ri++ = *rk;
	*rk++ = *rj;
	*rj++ = c;
    } while(--n);
}


static void
qs1(char* a, char* l)
{
    char *i, *j;
    int es;
    char	*lp, *hp;
    int	c;
    void	qsexc(), qstexc();
    unsigned n;

    es = qses;
start:
    if((n=l-a) <= es)
    {
	return;
    }
    
    n = es * (n / (2*es));
    hp = lp = a+n;
    i = a;
    j = l-es;

    while(1)
    {
	if(i < lp)
	{
	    if((c = (*qscmp)(i, lp)) == 0)
	    {
		qsexc(i, lp -= es);
		continue;
	    }

	    if(c < 0)
	    {
		i += es;
		continue;
	    }
	}

loop:
	if(j > hp)
	{
	    if((c = (*qscmp)(hp, j)) == 0)
	    {
		qsexc(hp += es, j);
		goto loop;
	    }

	    if(c > 0)
	    {
		if(i == lp)
		{
		    qstexc(i, hp += es, j);
		    i = lp += es;
		    goto loop;
		}

		qsexc(i, j);
		j -= es;
		i += es;
		continue;
	    }

	    j -= es;
	    goto loop;
	}

	if(i == lp)
	{
	    if(lp-a >= l-hp)
	    {
		qs1(hp+es, l);
		l = lp;
	    }
	    else
	    {
		qs1(a, lp);
		a = hp+es;
	    }

	    goto start;
	}

	qstexc(j, lp -= es, i);
	j = hp -= es;
    }
}


void
qsort( void* a, size_t n, size_t es, int(*fc)(const void*, const void*) )
{
    {
	static unsigned qsbufsize;

	if (es >= MINCPY)
	{
	    if (qsbuf == NULL)
	    {
		qsbuf = malloc(qsbufsize = es);
	    }
	    else if (qsbufsize < es)
	    {
		qsbuf = realloc(qsbuf, qsbufsize = es);
	    }
	}
    }

    qscmp = fc;
    qses = es;
    qs1(a, a+n*es);
}
