/* Copyright (C) 1995, by Motorola, Inc. */

#include <stdarg.h>
#include <stdio.h>

extern int __doscan( FILE*, const char*, va_list );

int
scanf( const char* format, ... )
{
    va_list ap;
    
    va_start( ap, format );
    return __doscan( stdin, format, ap );
}


int
fscanf( FILE* stream, const char* format, ... )
{
    va_list ap;
    va_start( ap, format );
    return __doscan( stream, format, ap );
}


int
sscanf( const char* string, const char *format, ... )
{
    va_list ap;
    FILE fake;
    
    /* build a fake stream */
    fake._cnt = strlen( string );
    fake._ptr = fake._buffer = (char*) string;
    fake._flag = _IOREAD;
    fake._file = NON_FILE;

    va_start ( ap, format );
    return __doscan( &fake, format, ap );
}
