/* Copyright (C) 1995, by Motorola, Inc. */

#include <stdarg.h>
#include <stdio.h>
#include <limits.h>


/* globally defined functions */
int __doprnt ( FILE*, const char*, va_list );

int
sprintf( char* string, const char *format, ... )
{
    va_list ap;
    int count;
    FILE fake;
    
    /* build a fake stream */
    fake._cnt = INT_MAX;
    fake._ptr = fake._buffer = string;
    fake._flag = _IOWRITE;
    fake._file = NON_FILE;

    va_start ( ap, format );
    count =  __doprnt( &fake, format, ap );

    /* terminate string */
    *fake._ptr = '\0';

    return count;
}

int
vsprintf( char* string, const char *format, va_list ap )
{
    FILE fake;
    int count;
    
    /* build a fake stream */
    fake._cnt = INT_MAX;
    fake._ptr = fake._buffer = string;
    fake._flag = _IOWRITE;
    fake._file = -1;
    
    count = __doprnt( &fake, format, ap );

    /* terminate string */
    *fake._ptr = '\0';

    return count;
}
