/* Copyright (C) 1995, by Motorola, Inc. */

#include <stddef.h>

#if ! defined( NULL )
#define	NULL	(void*) 0
#endif

extern size_t strspn();
extern char* strpbrk();

char*
strtok( char* s1, const char* s2)
{
   char* p, *q, *r;
   static char*	savept;

   /* first or subsequent call */
   if ( (char*) NULL == s1 )
   {
      p = savept;
   }

   else
   {
      p = s1;
   }


   /* return if no tokens remaining */
   if ( 0 == p )
   {
      return( (char*) NULL );
   }


   /* skip leading separators */
   q = p + strspn(p, s2);


   /* return if no tokens remaining */
   if ( '\0' == *q )
   {
      return( (char*) NULL );
   }


   /* move past token */
   if ( (char*) NULL == ( r = strpbrk(q, s2) ) )
   {
      savept = 0;	/* indicate this is last token */
   }
   else
   {
      *r = '\0';
      savept = ++r;
   }


   return( q );
}
