/* Copyright (C) 1995, by Motorola, Inc. */

#include <stdio.h>

/*
 * SETVBUF():
 *    The goal here is to
 *
 * Note:
 *
 *    function return value:
 *
 *    ERRNO:
 */

int
setvbuf( FILE* stream, char* buf, int mode, size_t size )
{
    /* reset the "buffered-ness" */
    stream->_flag &= ~( _IOFBF | _IOLBF | _IONBF );
    
    /* if a buffer is provided, use it */
    if ( buf != NULL )
    {
	/* free allocated buffers */
	if ( (stream->_buffer != NULL) && (stream->_flag & _IOABUF) )
	{
	    /* turn off allocated buffer flag */
	    stream->_flag &= ~_IOABUF;
            free( stream->_buffer - 1 ); /* don't forget the ungetc char! */
            stream->_buffer = NULL;      /* no buffer allocated */
	}
	
	stream->_buffer = buf;
	stream->_bufsiz = size;
	stream->_cnt = (stream->_cnt) ? size : 0;
    }

    /* check if mode is ok */
    if ( (mode != _IONBF) && (mode != _IOLBF) && (mode != _IOFBF) )
    {
	/* illegal mode */
	return -1;
    }
    
    stream->_flag |= mode;
    
    if ( mode == _IONBF )
    {
	stream->_ptr = stream->_buffer;
    }

    return 0;
}
