/* Copyright (C) 1995, by Motorola, Inc. */

#include <stdio.h>
#include <errno.h>

/* global variable declarations */
static char tmp_name_buffer[ L_tmpnam ] = "a709zXXX";
static int not_very_random_number = 666;

char*
tmpnam( char* s )
{
    char *name_ptr, *number;
    int  tval, rand_num;

    /* if called with a null pointer, use static buffer */
    if ( s == NULL )
    {
	name_ptr = tmp_name_buffer;
    }
    else
    {
	memcpy( s, tmp_name_buffer, L_tmpnam );
	name_ptr = s;
    }

    /* while searching for a unique file name */
    while ( 1 )
    {
	rand_num = not_very_random_number;
	
	/* point to the end of the ascii random number */
	number = name_ptr + 7;

	/* convert to ascii string */
	while ( 9 < rand_num )
	{
	    tval = rand_num;
	    rand_num /= 10;
	    *number-- = (tval - ( rand_num * 10)) + '0';
	}

	*number = rand_num + '0';

	not_very_random_number ++;

	/* if unique, break out of loop */
	if (( __access( name_ptr, __F_OK ) != 0 ) && ( errno == ENOENT ))
	{
	    /* file name is unique */
	    break;
	}
    }

    return name_ptr;
}
