/* Copyright (C) 1995, by Motorola, Inc. */

#if ! defined ( __TRANSCENDENTAL )

#define __TRANSCENDENTAL

#define _POLY1(x, c)    ((c)[0] * (x) + (c)[1])
#define _POLY2(x, c)    (_POLY1((x), (c)) * (x) + (c)[2])
#define _POLY3(x, c)    (_POLY2((x), (c)) * (x) + (c)[3])
#define _POLY4(x, c)    (_POLY3((x), (c)) * (x) + (c)[4])
#define _POLY5(x, c)    (_POLY4((x), (c)) * (x) + (c)[5])
#define _POLY6(x, c)    (_POLY5((x), (c)) * (x) + (c)[6])
#define _POLY7(x, c)    (_POLY6((x), (c)) * (x) + (c)[7])

#if defined ( __DSP561C__ ) || defined ( __DSP566C__ )
#define DSIGNIF   16
#define DMAXPOWTWO ( ( double ) ( 1L << DSIGNIF - 1 ) )
#elif defined ( __DSP56K__ ) || defined( __DSP563C__ )
#define DSIGNIF   24
#define DMAXPOWTWO ( ( double ) ( 1L << DSIGNIF - 1 ) )
#else      /* __DSP96K__ */
#define	DSIGNIF	  32
#define DMAXPOWTWO ( ( double ) ( 1L << DSIGNIF - 2 ) * 2.0 )
#endif

#if defined( __DSP561C__ ) || defined ( __DSP566C__ )
#define   MAXLONG   0x7FFF
#elif defined( __DSP56K__ ) || defined( __DSP563C__ )
#define   MAXLONG   0x7FFFFF
#else
#define   MAXLONG   0x7FFFFFFF
#endif

#define M_PI		3.14159265358979323846
#define M_PI_2		1.57079632679489661923
#define M_PI_4		0.78539816339744830962
#define M_2_PI		0.63661977236758134308
#define M_1_PI		0.31830988618379067154
#define M_2_SQRTPI	1.12837916709551257390
#define M_SQRT1_2	0.70710678118654752440
#define M_LN2		0.69314718055994530942
#define M_LOG10E	0.43429448190325182765
#define M_LOG2E	1.4426950408889634074
#define M_SQRT2	1.41421356237309504880

#define	H_PREC		( 1L << DSIGNIF / 2 ) * M_SQRT2 
#define	X_EPS		( 1.0 / ( H_PREC ) )

#define HUGE            HUGE_VAL
#define LN_MAXDOUBLE    88.722839
#define LN_MINDOUBLE   -103.278930

#define X_TLOSS         ( M_PI * DMAXPOWTWO )

#endif
