/* Copyright (C) 1995, by Motorola, Inc. */

#include <stdio.h>

/*
 * UNGETC():
 *    The goal here is to
 *
 *    Return value:
 *
 *    ERRNO:
 *        unused.
 */

int
ungetc( int c, FILE *stream )
{
    /* check stream for "readness" */
    if ( !( stream->_flag & _IOREAD ) && !( stream->_flag & _IORW ) )
    {
	stream->_flag |= _IOERR;
	return  EOF;
    }

    if ( c == EOF )
    {
	return EOF;
    }

    /* successfull calls clear EOF */
    stream->_flag &= ~_IOEOF;

    /* if nothing in read buffer */
    if ( !( stream->_flag & _IOREAD ) ||
	  ( 0 >= stream->_cnt ) )
    {
	*--stream->_ptr = c;
	stream->_cnt = 1;
	
	/* mark stream as having input (read) data in buffer */
	stream->_flag |= _IOREAD;

	/* faster to assume "update" stream than to check */
	stream->_flag &= ~_IOWRITE;
    }

    /* buffer has been filled */

    else if ( stream->_ptr == stream->_buffer )
    {
	*stream->_ptr = c;
    }

    else
    {
	*--stream->_ptr = c;
	stream->_cnt ++ ;
    }
    
    return c;
}
