/* Copyright (C) 1995, by Motorola, Inc. */

unsigned long
__udivdi3 ( dividend, divisor )
    unsigned long dividend, divisor;
{
    unsigned long quotient = 0, partial_dividend = 0;
    char dividend_bits[ 48 ];
    
    int i;
    
    for ( i = 0; i < 48; ++ i )
    {
	dividend_bits[i] = dividend & 1;
	dividend >>= 1;
    }
    
    for ( i = 47; i >= 0; -- i )
    {
	quotient <<= 1;

	partial_dividend <<= 1;
	partial_dividend |= dividend_bits[i];
	
	if ( partial_dividend >= divisor )
	{
	    partial_dividend -= divisor;
	    quotient |= 1;
	}
    }
    return quotient;
}


unsigned long
__umoddi3 ( dividend, divisor )
    unsigned long dividend, divisor;
{
    unsigned long partial_dividend = 0;
    char dividend_bits[ 48 ];

    int i;
    
    for ( i = 0; i < 48; ++ i )
    {
	dividend_bits[i] = dividend & 1;
	dividend >>= 1;
    }
    
    for ( i = 47; i >= 0; -- i )
    {
	partial_dividend <<= 1;
	partial_dividend |= dividend_bits[i];
	
	if ( partial_dividend >= divisor )
	{
	    partial_dividend -= divisor;
	}
    }
    return partial_dividend;
}

