/* Copyright (C) 1990, 1995, by Motorola, Inc. */

#include <stdlib.h>

#undef wcstombs

size_t
wcstombs ( char* s, const wchar_t* pwcs, size_t n )
{
    char buffer[MB_CUR_MAX];
    size_t converted, index;
    size_t c_elements_changed = 0;
    
    
    while ( n > c_elements_changed )
    {
	if (( converted = wctomb( buffer, *pwcs ) ) == -1 )
	{
	    return ( (size_t) -1 );
	}

	if ( converted == 0 )
	{
	    *s = '\0';
	    break;
	}
	
	/* make sure not to convert too many */
	index = 0;
	
	while ( n > c_elements_changed && converted )
	{
	    *s++ = buffer[ index ++ ];
	    c_elements_changed ++;
	    converted -- ;
	}		

	if ( 1 == index && '\0' == buffer[index - 1] )
	{
	    -- c_elements_changed;
	    break;
	}
	pwcs ++ ;
    }
    return ( c_elements_changed );
}
