/* Copyright (C) 1990, 1995, by Motorola, Inc. */

#include <stdlib.h>

#undef wctomb

int
wctomb ( char* s, wchar_t w_char )
{
    char scratch[ MB_CUR_MAX ];
    int converted, index;
            
    if ( NULL == s )
    {
	return 0;
    }

    /* simple case, when packed char contains nothing */
    if ( w_char == 0 )
    {
	*s = '\0';

	return 1;
    }
    
    index = MB_CUR_MAX - 1;
    
    while ( index >= 0 )
    {
	scratch[ index ] = w_char & 0xFF;
	if ( scratch[ index ] == '\0' )
	{
	    break;
	}
	
	index -- ;
	w_char >>= 8;
    }
    
    /* compensate for last index decrement, or bump past null */
    index ++ ;
    converted = MB_CUR_MAX - index;
    
    /* return characters */
    while ( index < MB_CUR_MAX )
    {
	*s++ = scratch[ index ++ ];
    }
    return( converted );
}
