/*******************************************************************************
 * C H A M E L E O N    S. D. K.                                               *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/include/chameleon/dsp.h                          $
 *     $Date:: 14/05/02 18:28                                                  $
 * $Revision:: 8                                                               $
 *-----------------------------------------------------------------------------*
 * This file is part of the Chameleon Software Development Kit                 *
 *                                                                             *
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#ifndef __RTEMS_DSP__
#define __RTEMS_DSP__

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************/

#define DSP_IOCTL_BOOT			0x00
#define DSP_IOCTL_GET_COUNT		0x01
#define DSP_IOCTL_WRITE_COMMAND		0x02
#define DSP_IOCTL_WRITE_FLAG0		0x03
#define DSP_IOCTL_WRITE_FLAG1		0x04
#define DSP_IOCTL_READ_FLAG2		0x05
#define DSP_IOCTL_READ_FLAG3		0x06

struct dsp_ioctl_rw_args_t
{
	rtems_unsigned32	data;		/* i/o */
	rtems_boolean		wait;		/* i */
	rtems_boolean		timeout;	/* o */
};

/******************************************************************************/

int	      dsp_init(int dsp_index, const rtems_unsigned8 *code);
rtems_boolean dsp_exit(int ref);

int           dsp_get_count(void);

rtems_boolean dsp_read_data(int ref, rtems_signed32 *data, rtems_unsigned32 count);
rtems_boolean dsp_write_data(int ref, const rtems_signed32 *data, rtems_unsigned32 count);

rtems_boolean dsp_write_command(int ref, rtems_unsigned8 command, rtems_boolean wait);

rtems_boolean dsp_write_flag0(int ref, rtems_boolean flag);
rtems_boolean dsp_write_flag1(int ref, rtems_boolean flag);
rtems_boolean dsp_read_flag2(int ref, rtems_boolean *flag);
rtems_boolean dsp_read_flag3(int ref, rtems_boolean *flag);

/******************************************************************************/


#ifdef __cplusplus
}
#endif

#endif

