/*******************************************************************************
 * C H A M E L E O N    S. D. K.                                               *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/include/chameleon/flash.h                        $
 *     $Date:: 14/05/02 16:53                                                  $
 * $Revision:: 6                                                               $
 *-----------------------------------------------------------------------------*
 * This file is part of the Chameleon Software Development Kit                 *
 *                                                                             *
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#ifndef __RTEMS_FLASH__
#define __RTEMS_FLASH__

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************/

#define FLASH_IOCTL_GET_SIZE		0x00
#define FLASH_IOCTL_SET_OFFSET		0x01
#define FLASH_IOCTL_GET_OFFSET		0x02
#define FLASH_IOCTL_IS_WRITTING		0x03

/******************************************************************************/

int	      flash_init(void);
rtems_boolean flash_exit(int ref);

rtems_boolean flash_read_data(int ref, rtems_unsigned32 offset, rtems_unsigned8 *data, rtems_unsigned32 count);
rtems_boolean flash_write_data(int ref, rtems_unsigned32 offset, const rtems_unsigned8 *data, rtems_unsigned32 count);

rtems_boolean flash_get_size(int ref, rtems_unsigned32 *size);
rtems_boolean flash_is_writting(int ref, rtems_boolean *flag);

/******************************************************************************/


#ifdef __cplusplus
}
#endif

#endif

