/*******************************************************************************
 * C H A M E L E O N    S. D. K.                                               *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/include/chameleon/panel.h                        $
 *     $Date:: 18/02/02 11:55                                                  $
 * $Revision:: 6                                                               $
 *-----------------------------------------------------------------------------*
 * This file is part of the Chameleon Software Development Kit                 *
 *                                                                             *
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#ifndef __RTEMS_PANEL__
#define __RTEMS_PANEL__

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************/

#define PANEL_LCD_MAX_LINE_LEN	16

struct panel_ioctl_out_led_t
{
	rtems_unsigned32	led_bits;
};

struct panel_ioctl_out_lcd_print_t
{
	rtems_unsigned8		row;
	rtems_unsigned8		col;
	char			text[PANEL_LCD_MAX_LINE_LEN + 1];
};

struct panel_ioctl_out_lcd_redefine_t
{
	rtems_unsigned8		code;
	rtems_unsigned8		data[8];
};

struct panel_ioctl_in_potentiometer_t
{
	rtems_boolean		is_valid;
	rtems_unsigned8		potentiometer;
	rtems_unsigned8		value;
};

struct panel_ioctl_in_keypad_t
{
	rtems_boolean		is_valid;
	rtems_unsigned32	key_bits;
};

struct panel_ioctl_in_encoder_t
{
	rtems_boolean		is_valid;
	rtems_unsigned8		encoder;
	rtems_signed8		increment;
};

#define PANEL_IOCTL_IN_READ			0x00
#define PANEL_IOCTL_IS_INPUT_EMPTY		0x01
#define PANEL_IOCTL_OUT_LED			0x02
#define PANEL_IOCTL_OUT_LCD_CLEAR		0x03
#define PANEL_IOCTL_OUT_LCD_PRINT		0x04
#define PANEL_IOCTL_OUT_LCD_REDEFINE		0x05
#define PANEL_IOCTL_IN_POTENTIOMETER		0x06
#define PANEL_IOCTL_IN_KEYPAD			0x07
#define PANEL_IOCTL_IN_ENCODER			0x08

/******************************************************************************/

int	      panel_init(void);
rtems_boolean panel_exit(int ref);

rtems_boolean panel_out_lcd_clear(int ref);
rtems_boolean panel_out_lcd_print(int ref, rtems_unsigned8 row, rtems_unsigned8 col, char *text);
rtems_boolean panel_out_lcd_redefine(int ref, rtems_unsigned8 code, const rtems_unsigned8 *data);
rtems_boolean panel_out_led(int ref, rtems_unsigned32 led_bits);

rtems_boolean panel_in_new_event(int ref, rtems_boolean wait);
rtems_boolean panel_in_potentiometer(int ref, rtems_unsigned8 *potentiometer, rtems_unsigned8 *value);
rtems_boolean panel_in_keypad(int ref, rtems_unsigned32 *key_bits);
rtems_boolean panel_in_encoder(int ref, rtems_unsigned8 *encoder, rtems_signed8 *increment);

/******************************************************************************/

#ifdef __cplusplus
}
#endif

#endif

