/*******************************************************************************
 * C H A M E L E O N    S. D. K.                                               *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/include/rtems/attr.h                             $
 *     $Date:: 18/02/02 11:55                                                  $
 * $Revision:: 4                                                               $
 *-----------------------------------------------------------------------------*
 * This file is part of the Chameleon Software Development Kit                 *
 *                                                                             *
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

/*  attr.h
 *
 *  This include file contains all information about the Object Attributes
 *  Handler.
 *
 */

#ifndef __RTEMS_ATTRIBUTES_h
#define __RTEMS_ATTRIBUTES_h

#ifdef __cplusplus
extern "C" {
#endif

#include "types.h"

/* types */

typedef rtems_unsigned32 rtems_attribute;

/* constants */

#define RTEMS_DEFAULT_ATTRIBUTES		0x00000000

#define RTEMS_NO_FLOATING_POINT			0x00000000 /* don't use FP HW */
#define RTEMS_FLOATING_POINT			0x00000001 /* utilize coprocessor */

#define RTEMS_LOCAL						0x00000000 /* local resource */
#define RTEMS_GLOBAL					0x00000002 /* global resource */

#define RTEMS_FIFO						0x00000000 /* process RTEMS_FIFO */
#define RTEMS_PRIORITY					0x00000004 /* process by priority */

#define RTEMS_SEMAPHORE_CLASS			0x00000030 /* mask */
#define RTEMS_COUNTING_SEMAPHORE		0x00000000
#define RTEMS_BINARY_SEMAPHORE			0x00000010
#define RTEMS_SIMPLE_BINARY_SEMAPHORE	0x00000020

#define RTEMS_NO_INHERIT_PRIORITY		0x00000000
#define RTEMS_INHERIT_PRIORITY			0x00000040

#define RTEMS_NO_PRIORITY_CEILING		0x00000000
#define RTEMS_PRIORITY_CEILING			0x00000080

#define RTEMS_APPLICATION_TASK			0x00000000
#define RTEMS_SYSTEM_TASK				0x00000100


#ifdef __cplusplus
}
#endif

#endif
/* end of include file */
