/*******************************************************************************
 * C H A M E L E O N    S. D. K.                                               *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/include/rtems/options.h                          $
 *     $Date:: 18/02/02 11:55                                                  $
 * $Revision:: 4                                                               $
 *-----------------------------------------------------------------------------*
 * This file is part of the Chameleon Software Development Kit                 *
 *                                                                             *
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

/*  options.h
 *
 *  This include file contains information which defines the
 *  options available on many directives.
 *
 */

#ifndef __RTEMS_OPTIONS_h
#define __RTEMS_OPTIONS_h

#ifdef __cplusplus
extern "C" {
#endif

#include "types.h"


/*
 *  The following type defines the control block used to manage
 *  option sets.
 */

typedef rtems_unsigned32 rtems_option;

/*
 *  The following constants define the individual options which may
 *  be used to compose an option set.
 */

#define RTEMS_DEFAULT_OPTIONS   0x00000000

#define RTEMS_WAIT				0x00000000        /* wait on resource */
#define RTEMS_NO_WAIT			0x00000001        /* do not wait on resource */

#define RTEMS_EVENT_ALL			0x00000000        /* wait for all events */
#define RTEMS_EVENT_ANY			0x00000002        /* wait on any event */


#ifdef __cplusplus
}
#endif

#endif
/* end of include file */
