/*******************************************************************************
 * C H A M E L E O N    S. D. K.                                               *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/include/rtems/rtems.h                            $
 *     $Date:: 18/02/02 11:55                                                  $
 * $Revision:: 6                                                               $
 *-----------------------------------------------------------------------------*
 * This file is part of the Chameleon Software Development Kit                 *
 *                                                                             *
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

/*  rtems.h
 *
 *  This include file contains information about RTEMS executive that
 *  is required by the application and is CPU independent.
 *
 */

#ifndef __RTEMS_h
#define __RTEMS_h

#ifdef __cplusplus
extern "C" {
#endif

#include "tasks.h"
#include "clock.h"
#include "timer.h"
#include "sem.h"
#include "message.h"
#include "event.h"
#include "signal.h"
#include "part.h"
#include "region.h"
#include "io.h"
#include "fatal.h"
#include "ratemon.h"
#include "extension.h"
#include "intr.h"
#include "dpmem.h"
#include "support.h"

#include "error.h"

/*
 *  The following define the constants which may be used in name searches.
 */

#define RTEMS_SEARCH_ALL_NODES		0
#define RTEMS_SEARCH_OTHER_NODES	0x7FFFFFFE
#define RTEMS_SEARCH_LOCAL_NODE		0x7FFFFFFF
#define RTEMS_WHO_AM_I				0

/*
 *  The following constant defines the minimum stack size which every
 *  thread must exceed.
 */

#define RTEMS_MINIMUM_STACK_SIZE	4096

/*
 *  Constant for indefinite wait.  (actually an illegal interval)
 */

#define RTEMS_NO_TIMEOUT			0


#ifdef __cplusplus
}
#endif

#endif
/* end of include file */
