################################################################################
# C H A M E L E O N    S. D. K.                                                #
################################################################################
#  $Archive:: /Chameleon.sdk/make/root.mak                                     $
#     $Date:: 14/05/02 17:12                                                   $
# $Revision:: 10                                                               $
#------------------------------------------------------------------------------#
# This file is part of the Chameleon Software Development Kit                  #
#                                                                              #
# Copyright (C) 2001 Soundart                                                  #
# www.soundart-hot.com                                                         #
# support@soundart-hot.com                                                     #
################################################################################

DEFINES    :=  -D__mc68000__ -D__BIG_ENDIAN__ -D__m68k__ -D__rtems__ -D__mot68 $(CCDEFINES)
INCLUDES   := $(addprefix -I, $(CCINCLUDES))
    	       
SHELL	   := /Chameleon.sdk/bin/coldfire/sh
ECHO       := /Chameleon.sdk/bin/coldfire/echo
RM         := /Chameleon.sdk/bin/coldfire/rm -f
SED	   := /Chameleon.sdk/bin/coldfire/sed
MKDIR	   := /Chameleon.sdk/bin/coldfire/mkdir -p
TEST	   := /Chameleon.sdk/bin/coldfire/test
GETPATH	   := /Chameleon.sdk/bin/coldfire/cygpath
DSPASM 	   := /Chameleon.sdk/bin/dsp56303/asm56300
DSPC       := /Chameleon.sdk/bin/dsp56303/g563c
DSPLNK 	   := /Chameleon.sdk/bin/dsp56303/dsplnk

CC         := /Chameleon.sdk/bin/coldfire/m68k-elf-gcc
CPP        := /Chameleon.sdk/bin/coldfire/m68k-elf-g++
AS         := /Chameleon.sdk/bin/coldfire/m68k-elf-as
AR         := /Chameleon.sdk/bin/coldfire/m68k-elf-ar
LD	   := /Chameleon.sdk/bin/coldfire/m68k-elf-ld
STRIP	   := /Chameleon.sdk/bin/coldfire/m68k-elf-strip

getpath	    = "$(shell $(GETPATH) -w $1)"
make        = $(MAKE) $(MAKECMDGOALS) -C $1

CFLAGS     := -m5200 -mmac -mhwdiv -msoft-float -malign-int -Wall -fno-hosted -fno-builtin -s $(DEFINES) $(INCLUDES)
ASFLAGS    := -m5206e -mmac -mhwdiv $(ASDEFINES)
LDFLAGS    := -m5200 -mmac -mhwdiv -nostartfiles -Wl,-n -Wl,--start-group
ARFLAGS    := -rc

DSPASMFLAGS:= -Q
DSPCFLAGS  := -B$(call getpath, /Chameleon.sdk/bin/dsp56303) -I$(call getpath, /Chameleon.sdk/bin/dsp56303/include) -j -P$(call getpath, /Chameleon.sdk/bin/dsp56303/lib)
DSPLNKFLAGS:= -Q

ifeq ($(findstring debug, $(MAKECMDGOALS)), debug)
  CFLAGS      += -DDEBUG
  ASFLAGS     += --defsym DEBUG=1
  DSPASMFLAGS += -G
  DSPLNKFLAGS += -G
else
  CFLAGS   += -O4 -fomit-frame-pointer -DNDEBUG
  LDFLAGS  += -Wl,-O,1 -Wl,--gc-sections
endif
