;*******************************************************************************
; C H A M E L E O N    S. D. K.                                                *
;*******************************************************************************
;  $Archive:: /Chameleon.sdk/src/examples/dspthru/dsp/polling.asm              $
;     $Date:: 14/05/02 17:12                                                   $
; $Revision:: 5                                                                $
;------------------------------------------------------------------------------*
; This file is part of the Chameleon Software Development Kit                  *
;                                                                              *
; Copyright (C) 2001-2002 Soundart                                             *
; www.soundart-hot.com                                                         *
; support@soundart-hot.com                                                     *
;*******************************************************************************

;*******************************************************************************
; This example shows how access audio I/O using polling.
; The program uses a ramp to smooth the volume changes.
;*******************************************************************************

 	nolist
	page	255,0
	opt	MU,S,CC,CEX,MEX,MD
	list

	nolist
	include	"SDK\include\dsp\dsp_equ.asm"
	list


;*******************************************************************************
	org	Y:$000000

MasterVolumeTarget:
	ds	1		; Filled on Start
MasterVolume:
	ds	1		; Filled on Start


;*******************************************************************************
	org	P:$000100

Start:
	CLR	A

	;**********************************************************************
	; Enable ESSI0 transmit and receive
	;**********************************************************************
	BSET	#CRB_TE0,X:<<CRB0		; Enable Transmit 0
	BSET	#CRB_RE,X:<<CRB0		; Enable Receive  0

	;**********************************************************************
	; Init Master Volume variables
	;**********************************************************************
	MOVE	A,Y:MasterVolumeTarget
	MOVE	A,Y:MasterVolume

	BRSET	#SSISR_RFS,X:<<SSISR0,*		; Wait while receiving left frame
	BRCLR	#SSISR_RFS,X:<<SSISR0,*		; Wait while receiving right frame

MainLoop:	
	BRCLR	#HSR_HRDF,X:<<HSR,NoHostData	; host data input?
	MOVEP	X:<<HRX,Y:MasterVolumeTarget	; set new master volume value
NoHostData:

	;**********************************************************************
	; Loop for channel
	;**********************************************************************

	MOVE	Y:MasterVolume,X0		; current volume value
	
	DO	#2,ChannelLoop
	  BRCLR	#SSISR_RDF,X:<<SSISR0,*		; Wait until receive register is full
	  MOVEP	X:<<RX0,Y0			; Get new input sample
	  MPYR	X0,Y0,B				; Scale the input sample according to the volume curve
	  BRCLR	#SSISR_TDE,X:<<SSISR0,*		; Wait until transmiter register is empty
	  MOVEP	B,X:<<TX00			; Set new output sample
ChannelLoop:

	MOVE	Y:MasterVolumeTarget,B		; target volume value
	MOVE	Y:MasterVolume,A		; current volume value
	SUB	A,B				
	ASR	#10,B,B				; increment
	ADD	A,B				; current volume value += increment
	NOP
	MOVE	B,Y:MasterVolume

	BRA	MainLoop

	end	Start
