;*******************************************************************************
; C H A M E L E O N    S. D. K.                                                *
;*******************************************************************************
;  $Archive:: /Chameleon.sdk/src/examples/levelmeter/dsp/main_loop.asm         $
;     $Date:: 14/05/02 19:03                                                   $
; $Revision:: 5                                                                $
;------------------------------------------------------------------------------*
; This file is part of the Chameleon Software Development Kit                  *
;                                                                              *
; Copyright (C) 2001-2002 Soundart                                             *
; www.soundart-hot.com                                                         *
; support@soundart-hot.com						       *
;*******************************************************************************

;*******************************************************************************
;  Main Loop for the level meter application with dsp specific code
;*******************************************************************************

	; Write each output value to the host port so when the ColdFire 
	; reads the value, it reads the most recent computed value

	MOVEP	Y:Levels,X:<<HTX

	; Check if a new volume value has been received from the ColdFire

	BRCLR	#HSR_HRDF,X:<<HSR,NoHostDataInput	; host data input?
	MOVEP	X:<<HRX,X0				; set new master volume value
	MOVE	X0,X:MasterVolumeTarget

NoHostDataInput:

	;**********************************************************************
	; Loop for the two channels
	;**********************************************************************

	DO	#2,ChannelLoop

	  BRCLR	#SSISR_RDF,X:<<SSISR0,*		; Wait until receive register is full

	  MOVEP	X:<<RX0,Y0			; Get new input sample in Y0
	  MOVE	X:MasterVolume,X0
	  MPY	X0,Y0,A				; Scale the input sample with the volume value

	  BRCLR	#SSISR_TDE,X:<<SSISR0,*		; Wait until transmiter register is empty

	  MOVEP	A,X:<<TX00			; Send new output sample the audio Codec

	  BSR	ComputeEnvelope			; Calculate the envelope value
	  BSR	UpdateLevels			; Prepare data to send to the ColdFire
	  NOP

ChannelLoop:

	  BSR	SmoothVolume			; Apply volume smoothing ramp

