;*******************************************************************************
; C H A M E L E O N    S. D. K.                                                *
;*******************************************************************************
;  $Archive:: /Chameleon.sdk/src/examples/levelmeter/dsp/process.asm           $
;     $Date:: 14/05/02 19:03                                                   $
; $Revision:: 4                                                                $
;------------------------------------------------------------------------------*
; This file is part of the Chameleon Software Development Kit                  *
;                                                                              *
; Copyright (C) 2001-2002 Soundart                                             *
; www.soundart-hot.com                                                         *
; support@soundart-hot.com						       *
;*******************************************************************************


;*******************************************************************************
;  Level meter signal processing routines
;*******************************************************************************

 	nolist
	page	255,0
	opt	MU,S,CC
	list


	org	P:

;**********************************************************************
; Level calculation
; Envelope follower implementation
;**********************************************************************

ComputeEnvelope:

	; Check if monitoring the input or the ouput
	
	BRCLR	#HSR_HF0,X:<<HSR,Monitoring_Output	; Flag 0 (HSR_HF0) is set/clear by the
							; ColdFire to point what signal to monitor

Monitoring_Input:

	MOVE	Y0,A

Monitoring_Output:

	ABS	A

	; Check if attcking  or releasing to select
	; the appropiate coefficients.

	MOVE	Y:(R4+2),Y1
	CMP	Y1,A
	BLT	Releasing

Attacking:

	MOVE	#GAT,X1
	MOVE	X1,Y:(R4)	
	MOVE	#AT,X1
	MOVE	X1,Y:(R4+1)

	BRA	DiffEq	

Releasing:

	MOVE	#GRT,X1
	MOVE	X1,Y:(R4)	
	MOVE	#RT,X1
	MOVE	X1,Y:(R4+1)

DiffEq:

	; System difference equation

	CLR	B		A,X1		Y:(R4)+,Y1	 
	MPY	Y1,X1,B		Y:(R4)+,Y1	
	MOVE	Y:(R4),X1	
	MAC	Y1,X1,B		
	NOP
	MOVE	B,Y:(R4)+

	RTS


;**********************************************************************
; L & R Levels update
; Format the data of both channels levels to send to the ColdFire
;**********************************************************************

UpdateLevels:

	MOVE	R4,A
	CMP	#EnvelopeGainR,A	; If processing the R Channel, wait
					; to the next sample to update
					; both R & L values
	BEQ	TimeToUpdate

	RTS

TimeToUpdate:

	MOVE		Y:LevelR,A0	; Concatenate the 12 MSB of each channel Levels
	EXTRACTU	#$00C024,B,B
	EXTRACTU	#$00C00C,A,A
	INSERT		#$00C00C,A0,B
	NOP
	MOVE		B0,Y:Levels	; Update the Levels value

	RTS


;**********************************************************************
; Volume Smoothing ramp
; Makes the volume ramping to smooth abrupt volume changes
;**********************************************************************

SmoothVolume:

	MOVE	X:MasterVolume,A		; current volume value
	MOVE	X:MasterVolumeTarget,B		; target left volume value
	SUB	A,B
	ASR	#10,B,B				; increment
	ADD	A,B				; current volume value += increment
	NOP
	MOVE	B,X:MasterVolume
	
	RTS
