//**********************************************************************
//  C H A M E L E O N    S. D. K.                                      *
//**********************************************************************
//  $Archive:: /Chameleon.sdk/src/examples/levelmeter/scilab/ioutils.s $
//  $Date:: 18/02/02 11:53                                             $
//  $Revision:: 2                                                      $
//---------------------------------------------------------------------*
// This file is part of the Chameleon Software Development Kit         *
//                                                                     *
// Copyright (C) 2001-2002 Soundart                                    *
// www.soundart-hot.com                                                *
// support@soundart-hot.com                                            *
// ********************************************************************/

// SciLab 2.6 utility functions for read/write DSP56303 simulator files


//*********************************************************

function y = loadsim(filename)

	filename = filename + '.io';
	y = fscanfMat(filename);

endfunction

//*********************************************************

function y = loadsimst(filename)

	filename = filename + '.io';

	x = fscanfMat(filename);

	L = floor(length(x)/2);

	if L == 0
		error('invalid input file size');
		abort;
	end

	y = zeros(L,2)

	for i = 1:(2*L)

		m = pmodulo(i,2) 
		if m == 0
			y(ceil(i/2),2) = x(i)
		else
			y(ceil(i/2),1) = x(i)
		end

	end

endfunction


//*********************************************************

function savesim(x, filename)

	filename = filename + '.io';
	fprintfMat(filename, x, '%1.15f');

endfunction

//*********************************************************

function wav2sim(filename)

	filenamewav = filename + '.wav';
	[y,fs,bits] = wavread(filename);
	savesim(y,filename);

endfunction


//*********************************************************

function sim2wav(filename, fs, bits, channels)

	if channels == 1
		y = loadsim(filename);

	elseif channels == 2
		y = loadsimst(filename);

	else
		error('Unsupported number of channels');
	end

	fileneme = filename + '.wav';
	wavwrite(y,fs,bits,filename);

endfunction

