//**********************************************************************
//  C H A M E L E O N    S. D. K.                                      *
//**********************************************************************
//  $Archive:: /Chameleon.sdk/src/examples/levelmeter/scilab/levelmete $
//  $Date:: 18/02/02 11:53                                             $
//  $Revision:: 2                                                      $
//---------------------------------------------------------------------*
// This file is part of the Chameleon Software Development Kit         *
//                                                                     *
// Copyright (C) 2001-2002 Soundart                                    *
// www.soundart-hot.com                                                *
// support@soundart-hot.com                                            *
// ********************************************************************/

// SciLab 2.6 functions for the Level Meter application


//*****************************************************

function [y] = envelop(x,AT,RT)

	L = length(x);
	y = zeros(1,L);

	TC = AT;
	G = (1 - TC);

	y(1) = G*abs(x(1));

	for i = 2:L
		in = abs(x(i));

		if in >= y(i-1)
			TC = AT;
		else
			TC = RT;
		end

		G = 1 - TC;
   		y(i) = TC*y(i-1) + G*in;

	end
endfunction

//*****************************************************

function levelmeter_test()

	[x,fs,bits] = wavread("test.wav");
	AT = 0.15;
	RT = 0.999;
	y = envelop(x(:,1),AT,RT);
	xbasc();
	subplot(2,1,1);
	plot(x(:,1));
	subplot(2,1,2);
	plot(y)

endfunction

