/*******************************************************************************
 * C H A M E L E O N                                                           *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/src/examples/MONOSYNTH/MonoSynthPanel.h          $
 *     $Date:: 13/05/02 20:11                                                  $
 * $Revision:: 1                                                               $
 *-----------------------------------------------------------------------------*
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#ifndef __MONOSYNTH_PANEL_H__
#define __MONOSYNTH_PANEL_H__

#include "panel.h"
#include "PanelModeHandler.h"
#include "MonoSynthPanelModeInit.h"
#include "MonoSynthPanelModePreset.h"
#include "MonoSynthPanelModeEdit.h"
#include "MonoSynthPanelModeSave.h"
#include "MonoSynthPanelModeAssign.h"
#include "MonoSynthPanelModeMidi.h"

////////////////////////////////////////////////////////////////////////////////
#define PANEL(x)	((CMonoSynthPanel *) x)
////////////////////////////////////////////////////////////////////////////////

class CMonoSynthPanel : public CPanel
{
public:
	enum
	{
		kPanelModeInvalid = 0,
		kPanelModeInit,
		kPanelModePreset,
		kPanelModeEdit,
		kPanelModeSave,
		kPanelModeAssign,
		kPanelModeMidi,
	};

private:
	int m_nPanelMode;
	CPanelModeHandler *m_pPanelModeHandler;
	
	CMonoSynthPanelModeInit m_panelModeInit;
	CMonoSynthPanelModePreset m_panelModePreset;
	CMonoSynthPanelModeEdit m_panelModeEdit;
	CMonoSynthPanelModeSave m_panelModeSave;
	CMonoSynthPanelModeAssign m_panelModeAssign;
	CMonoSynthPanelModeMidi m_panelModeMidi;
	
protected:
	virtual BOOL Initialize(void);
	virtual void OnMessage(CMessage *pMsg);
	
public:
	void SendMsgChangeMode(int nMode);
	void SendMsgParameterChanged(WORD wID);
	void SendMsgPresetChanged(BYTE byPreset);
	
	void Refresh(void);
};

//////////////////////////////////////////////////////////////////////////////

#endif
