/*******************************************************************************
 * C H A M E L E O N                                                           *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/src/examples/MONOSYNTH/MonoSynthPanelModeEdit.h  $
 *     $Date:: 13/05/02 20:11                                                  $
 * $Revision:: 1                                                               $
 *-----------------------------------------------------------------------------*
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#ifndef __MONOSYNTH_PANEL_MODE_EDIT_H__
#define __MONOSYNTH_PANEL_MODE_EDIT_H__

#include "menus.h"
#include "PanelModeHandler.h"

////////////////////////////////////////////////////////////////////////////////

class CMonoSynthPanelModeEdit : public CPanelModeHandler
{
private:
	CMenuItem m_menu;
	rtems_id  m_idTimer0, m_idTimer1, m_idTimer2;
	DWORD     m_dwLastKeyBits;
	WORD	  m_wSelectedID;
	int	  m_nIncrement;
	int	  m_nEncoderValue;
	int	  m_nEncoderFactor;
	BOOL	  m_bModified;
	BYTE	  m_byCtrlSelected;

	void AddMenuParameter(CMenuItem *pMenu, WORD wID);
	void SetEncoderFactor(void);

public:
	virtual BOOL Initialize(CPanel *pPanel);

	virtual void BeginMode(int nModeBefore);
	virtual void EndMode(void);

	virtual void OnPotentiometer(BYTE byPot, BYTE byValue);
	virtual void OnEncoder(BYTE byEncoder, char nInc);
	virtual void OnKeypad(DWORD dwKeyBits);
	virtual void OnTimer(rtems_id timer_id);
	virtual void OnParameterChanged(WORD wID);
	virtual void OnPresetChanged(BYTE byPreset);

	virtual void Display(void);
};

////////////////////////////////////////////////////////////////////////////////

#endif
