/*******************************************************************************
 * C H A M E L E O N                                                           *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/src/examples/MONOSYNTH/MonoSynthPanelModePreset. $
 *     $Date:: 13/05/02 20:11                                                  $
 * $Revision:: 1                                                               $
 *-----------------------------------------------------------------------------*
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#ifndef __MONOSYNTH_PANEL_MODE_PRESET_H__
#define __MONOSYNTH_PANEL_MODE_PRESET_H__

#include "PanelModeHandler.h"

////////////////////////////////////////////////////////////////////////////////

class CMonoSynthPanelModePreset : public CPanelModeHandler
{
private:
	rtems_id m_idTimer0;
	rtems_id m_idTimer1;
	int      m_nEncoderValue;
	DWORD    m_dwLastKeyBits;
	BYTE	 m_byPreset;
	BOOL     m_bStatus;
	BOOL     m_bModified;
	int	 m_nPresetInc;
	int	 m_nCounter;

private:
	void OnChangePreset(void);

public:
	virtual BOOL Initialize(CPanel *pPanel);

	virtual void BeginMode(int nModeBefore);
	virtual void EndMode(void);

	virtual void OnPotentiometer(BYTE byPot, BYTE byValue);
	virtual void OnEncoder(BYTE byEncoder, char nInc);
	virtual void OnKeypad(DWORD dwKeyBits);
	virtual void OnTimer(rtems_id idTimer);
	virtual void OnPresetChanged(BYTE byPreset);

	virtual void Display(void);
};

////////////////////////////////////////////////////////////////////////////////

#endif
