/*******************************************************************************
 * C H A M E L E O N                                                           *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/src/examples/MONOSYNTH/MonoSynthPanelModeSave.h  $
 *     $Date:: 13/05/02 20:11                                                  $
 * $Revision:: 1                                                               $
 *-----------------------------------------------------------------------------*
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#ifndef __MONOSYNTH_PANEL_MODE_SAVE_H__
#define __MONOSYNTH_PANEL_MODE_SAVE_H__

#include "PanelModeHandler.h"

////////////////////////////////////////////////////////////////////////////////

class CMonoSynthPanelModeSave : public CPanelModeHandler
{
private:
	enum
	{
		kStageAsking = 0,
		kStagePresetNumber,
		kStagePresetName,
		kStageWaitingSave,
		kStageWaitingPreset
	};

private:
	rtems_id m_idTimer0;
	rtems_id m_idTimer1;
	rtems_id m_idTimer2;
	BYTE     m_bySavePreset;
	DWORD    m_dwLastKeyBits;
	BOOL	 m_bStatus;
	BOOL	 m_bResponse;
	int	 m_nStage;
	int      m_nEncoderValue;
	int	 m_nIncrement;
	int	 m_nCol;
	
	char	 m_strPresetName[16+1];

public:
	virtual BOOL Initialize(CPanel *pPanel);

	virtual void BeginMode(int nModeBefore);
	virtual void EndMode(void);

	virtual void OnEncoder(BYTE byEncoder, char nInc);
	virtual void OnKeypad(DWORD dwKeyBits);
	virtual void OnTimer(rtems_id timer_id);
	virtual void OnPresetChanged(BYTE byPreset);

	virtual void Display(void);
};

////////////////////////////////////////////////////////////////////////////////

#endif
