/*******************************************************************************
 * C H A M E L E O N                                                           *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/src/examples/MONOSYNTH/dsp.h                     $
 *     $Date:: 13/05/02 20:11                                                  $
 * $Revision:: 1                                                               $
 *-----------------------------------------------------------------------------*
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#ifndef __DSP_H__
#define __DSP_H__

#include "message.h"

//////////////////////////////////////////////////////////////////////////////

class CDsp : public CMessageHandler
{
private:
	int m_nDspRef;
	DWORD m_dwDataSentLen;

protected:
	virtual void OnMessage(CMessage *pMsg);

public:
	CDsp(void)
	{
		m_nDspRef = 0;
	}
	
	BOOL Create(const BYTE dspCode[]);

public:
	void SendMsgUpdate(void);
	void SendMsgWriteBlockP(DWORD dwAddr, DWORD dwLen, rtems_signed32 *pData);
	void SendMsgWriteBlockX(DWORD dwAddr, DWORD dwLen, rtems_signed32 *pData);
	void SendMsgWriteBlockY(DWORD dwAddr, DWORD dwLen, rtems_signed32 *pData);
	void SendMsgWriteWordP(DWORD dwAddr, rtems_signed32 dwWord);
	void SendMsgWriteWordX(DWORD dwAddr, rtems_signed32 dwWord);
	void SendMsgWriteWordY(DWORD dwAddr, rtems_signed32 dwWord);
	void SendMsgCopyBlockP(DWORD dwAddrSrc, DWORD dwAddrDst, DWORD dwLen);
	void SendMsgFillBlockX(DWORD dwAddr, DWORD dwLen, rtems_signed32 dwWord);
	void SendMsgFillBlockY(DWORD dwAddr, DWORD dwLen, rtems_signed32 dwWord);
};

//////////////////////////////////////////////////////////////////////////////

#endif
