;*******************************************************************************
; C H A M E L E O N   DSP Assembler file                                       *
;*******************************************************************************
; Copyright (C) 2001-2002 Soundart                                             *
; www.soundart-hot.com                                                         *
; support@soundart-hot.com                                                     *
;*******************************************************************************
;
; MODULE: Addk
;	This block of code adds a constant value to the input buffer:
;
;	output[i] = input[i] + K
;
; ARGUMENTS:
;	(X)   = InAddr		- Input buffer (Y)
;	(X+1) = OutAddr		- Output buffer (X)
;	(X+2) = Constant	- Constant to add
;
;******************************************************************************

	define	R_In			'R5'
	define	R_Out			'R1'

;===============================CODE=====================================

	MOVE	X:(R_X)+,R_In		; (X)   = InAddr (Y)
	MOVE	X:(R_X)+,R_Out		; (X+1) = OutAddr (X)
	MOVE	X:(R_X)+,X0		; (X+2) = Constant

	NOP
	TFR	X0,A		Y:(R_In)+,Y0

	BEGIN_LOOP
	;----------------------------------------------------------------
	  ADD	Y0,A		Y:(R_In)+,Y0
	  NOP
	  TFR	X0,A		A,X:(R_Out)+
	;----------------------------------------------------------------
	END_LOOP

;===============================CODE=====================================

	undef	R_In
	undef	R_Out
