;*******************************************************************************
; C H A M E L E O N   DSP Assembler file                                       *
;*******************************************************************************
; Copyright (C) 2001-2002 Soundart                                             *
; www.soundart-hot.com                                                         *
; support@soundart-hot.com                                                     *
;*******************************************************************************
;
; MODULE: Amp
;	This block of code fills the output buffer with the element by element
;	multiplication of the input buffers.
;
;	Output[i] = Input1[i] * Input2[i]
;
; ARGUMENTS:
;	(X)   = In1Addr		- Input1 buffer (X)
;	(X+1) = In2Addr		- Input2 buffer (Y)
;	(X+2) = OutAddr		- Output buffer (Y)
;
;******************************************************************************

	define	R_In1			'R1'
	define	R_In2			'R5'
	define	R_Out			'R6'

;===============================CODE=====================================

	MOVE	X:(R_X)+,R_In1		; (X)   = In1Addr (X)
	MOVE	X:(R_X)+,R_In2		; (X+1) = In2Addr (Y)
	MOVE	X:(R_X)+,R_Out		; (X+2) = OutAddr (Y)

	NOP
	NOP
	MOVE	X:(R_In1)+,X0		Y:(R_In2)+,Y0

	BEGIN_LOOP
	;----------------------------------------------------------------
	  MPYR	X0,Y0,A			Y:(R_In2)+,Y0
	  NOP
	  MOVE	A,Y:(R_Out)+		X:(R_In1)+,X0
	;----------------------------------------------------------------
	END_LOOP

;===============================CODE=====================================

	undef	R_In1
	undef	R_In2
	undef	R_Out
