;*******************************************************************************
; C H A M E L E O N   DSP Assembler file                                       *
;*******************************************************************************
; Copyright (C) 2001-2002 Soundart                                             *
; www.soundart-hot.com                                                         *
; support@soundart-hot.com                                                     *
;*******************************************************************************
;
; MODULE: Mixer
;	This piece of code adds the input buffers element by element, scaling the 
;	first two before by using the given scale values.
;
;	Out[i] = In1[i]*ScaleValue1 + In2[i]*ScaleValue2 + In3[i] + In4[i]
;
; ARGUMENTS:
;	(X)   = In1Addr		- Input1 buffer (X)
;	(X+1) = In2Addr		- Input2 buffer (X)
;	(X+2) = In3Addr		- Input3 buffer (Y)
;	(X+3) = In4Addr		- Input4 buffer (Y)
;	(X+4) = OutAddr		- Output buffer (Y)
;	(X+5) = ScaleValue1	- Scaling constant for input 1
;	(X+6) = ScaleValue2	- Scaling constant for input 2
;
;******************************************************************************

	define	R_In1			'R1'
	define	R_In2			'R2'
	define	R_In3			'R5'
	define	R_In4			'R6'
	define	R_Out			'R7'

;===============================CODE=====================================

	MOVE 	X:(R_X)+,R_In1		; (X)   = In1Addr (X)
	MOVE 	X:(R_X)+,R_In2		; (X+1) = In2Addr (X)
	MOVE 	X:(R_X)+,R_In3		; (X+2) = In3Addr (Y)
	MOVE 	X:(R_X)+,R_In4		; (X+3) = In4Addr (Y)
	MOVE	X:(R_X)+,R_Out		; (X+4) = OutAddr (Y)
	MOVE	X:(R_X)+,X0		; (X+5) = ScaleValue1
	MOVE	X:(R_X)+,Y0		; (X+6) = ScaleValue2

	MOVE	X:(R_In1)+,X1
	MPY	X0,X1,A		X:(R_In2)+,Y1

	BEGIN_LOOP
	;----------------------------------------------------------------
	  MACR	Y0,Y1,A		Y:(R_In3)+,Y1
	  ADD	Y1,A		X:(R_In1)+,X1	Y:(R_In4)+,Y1
	  ADD	Y1,A		X:(R_In2)+,Y1
	  NOP
	  MPY	X0,X1,A		A,Y:(R_Out)+
	;----------------------------------------------------------------
	END_LOOP

;===============================CODE=====================================

	undef	R_In1
	undef	R_In2
	undef	R_In3
	undef	R_In4
	undef	R_Out
