;*******************************************************************************
; C H A M E L E O N   DSP Assembler file                                       *
;*******************************************************************************
; Copyright (C) 2001-2002 Soundart                                             *
; www.soundart-hot.com                                                         *
; support@soundart-hot.com                                                     *
;*******************************************************************************
;
; MODULE: Noise
;	This module computes uniform pseudo-white noise using the linear
;	congruential method for random number generation (Knuth, volume II of the
;	Art of Computer Programming).
;
;	This code is based in the file unoise.asm from the musickit source code.
;	MusicKit is a set of classes and object templates used in NeXT computers
;	(which include a DSP56002 chip) to build applications for music composition,
;	synthesis and performance (author: Julius Smith, Copyright 1990 NeXT 
;	Computer, Inc. All rights reserved.).
;
; ARGUMENTS:
;	OutAddr		- Output buffer (X)
;	Seed		- Semilla del algoritmo de generacin
;
;******************************************************************************

	define	R_Out			'R2'

;===============================CODE=====================================

	MOVE	X:(R_X)+,R_Out			; (X)   = OutAddr (X)
	CLR	B		X:(R_X),X0	; (X+1) = Seed

	MOVE	#2,B0
	TFR	B,A		#5609937,X1
	MAC	X0,X1,a
	ASR	A

	BEGIN_LOOP_MINUS
	;----------------------------------------------------------------
	  TFR	B,A		A0,X0
	  MAC	X0,X1,a		X0,X:(R_Out)+
	  ASR	A
	;----------------------------------------------------------------
	END_LOOP

	MOVE	A0,X:(R_Out)+
	MOVE	A0,X:(R_X)+

;===============================CODE=====================================

	undef	R_Out
