;*******************************************************************************
; C H A M E L E O N   DSP Assembler file                                       *
;*******************************************************************************
; Copyright (C) 2001-2002 Soundart                                             *
; www.soundart-hot.com                                                         *
; support@soundart-hot.com                                                     *
;*******************************************************************************
;
; MODULE: Out
;	This module accumulates the input buffer into the output DAC buffers.
;
;	OUT_L_CHUNK[i] = Input1[i]
;	OUT_R_CHUNK[i] = Input2[i]
;
; ARGUMENTS:
;	(X)   = In1Addr		- Input1 buffer (X)
;	(X+1) = In2Addr		- Input2 buffer (X)
;
;******************************************************************************

	define	R_In1			'R5'
	define	R_In2			'R1'
	define	R_OutLeft		'R2'
	define	R_OutRight		'R6'

;===============================CODE=====================================

	MOVE	X:(R_X)+,R_In1		; (X)   = In1Addr (X)
	MOVE	#OUT_L_CHUNK,R_OutLeft	; Left DAC Buffer
	MOVE	X:(R_X)+,R_In2		; (X+1) = In2Addr (X)
	MOVE	#OUT_R_CHUNK,R_OutRight	; Right DAC Buffer

	MOVE	X:(R_In1)+,X0
	MOVE	X:(R_OutLeft),A
	BEGIN_LOOP
	;----------------------------------------------------------------
	  ADD	X0,A			Y:(R_OutRight),B	X:(R_In2)+,X0
	  ADD	X0,B			X:(R_In1)+,X0
	  MOVE	A,X:(R_OutLeft)+
	  MOVE	B,Y:(R_OutRight)+	X:(R_OutLeft),A
	;----------------------------------------------------------------
	END_LOOP

;===============================CODE=====================================

	undef	R_In1
	undef	R_In2
	undef	R_OutLeft
	undef	R_OutRight
