;*******************************************************************************
; C H A M E L E O N   DSP Assembler file                                       *
;*******************************************************************************
; Copyright (C) 2001-2002 Soundart                                             *
; www.soundart-hot.com                                                         *
; support@soundart-hot.com                                                     *
;*******************************************************************************
;
; MODULE: Scale
;	This code scales the input buffer using the given constant:
;
;	Output[i] = Input[i] * ScaleValue
;
; ARGUMENTS:
;	(X)   = InAddr		- Input buffer (X)
;	(X+1) = OutAddr		- Output buffer (Y)
;	(X+2) = ScaleValue	- Scaling factor
;
;******************************************************************************

	define	R_In			'R1'
	define	R_Out			'R5'

;===============================CODE=====================================

	MOVE 	X:(R_X)+,R_In		;(X)   = InAddr (X)
	MOVE	X:(R_X)+,R_Out		;(X+1) = OutAddr (Y)
	MOVE	X:(R_X)+,Y1		;(X+2) = ScaleValue

	NOP
	MOVE	X:(R_In)+,X1
	MPYR	X1,Y1,A		X:(R_In)+,X1

	BEGIN_LOOP_MINUS
	;----------------------------------------------------------------
	  MPYR	X1,Y1,A		X:(R_In)+,X1	A,Y:(R_Out)+
	  NOP
	;----------------------------------------------------------------
	END_LOOP

	MOVE	A,Y:(R_Out)+

;===============================CODE=====================================

	undef	R_In
	undef	R_Out
