/*******************************************************************************
 * C H A M E L E O N                                                           *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/src/examples/MONOSYNTH/hash.cpp                  $
 *     $Date:: 13/05/02 20:11                                                  $
 * $Revision:: 1                                                               $
 *-----------------------------------------------------------------------------*
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#include <stdlib.h>
#include <rtems.h>
#include "hash.h"

CHashTable::CHashTable(void)
{
	m_pBlockAllocated = NULL;
	m_dwBlockCount = 0;

	for (int i=0; i<kHashSize ;i++)
		m_table[i] = NULL;
}

CHashTable::~CHashTable(void)
{
	// Hash Destructor not implemented still!!
}

CHashTable::Node *CHashTable::NewNode(void)
{
	if (m_dwBlockCount == 0)
	{
		if ((m_pBlockAllocated = new Node[kBlockSize]) == NULL)
			return NULL;

		m_dwBlockCount = kBlockSize;
	}

	m_dwBlockCount--;
	
	return m_pBlockAllocated++;
}

void *CHashTable::LookUp(WORD wKey)
{
	DWORD dwHash = GetHashKey(wKey) % kHashSize;
	Node *pNode;

	for (pNode=m_table[dwHash]; (pNode != NULL) ;pNode=pNode->pNextNode)
	{
		if (pNode->wKey == wKey)
			return pNode->pData;
	}

	return NULL;
}

void *CHashTable::Add(WORD wKey, void *pData)
{
	Node *pNode;
	DWORD dwHash = GetHashKey(wKey) % kHashSize;

	for (pNode=m_table[dwHash]; (pNode != NULL) ;pNode=pNode->pNextNode)
	{
		if (pNode->wKey == wKey)
		{
			void *pDataOld = pNode->pData;
			pNode->pData = pData;
			return pDataOld;
		}
	}

	pNode = NewNode();

	if (pNode)
	{
		pNode->wKey = wKey;
		pNode->pData = pData;
		pNode->pNextNode = m_table[dwHash];
		m_table[dwHash] = pNode;
	}

	return NULL;
}
