/*******************************************************************************
 * C H A M E L E O N                                                           *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/src/examples/MONOSYNTH/hash.h                    $
 *     $Date:: 13/05/02 20:11                                                  $
 * $Revision:: 1                                                               $
 *-----------------------------------------------------------------------------*
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#ifndef __HASH_H__
#define __HASH_H__

class CHashTable
{
private:

	enum
	{
		kHashSize  = 17,
		kBlockSize = 32,
	};
	
	inline DWORD GetHashKey(WORD wKey)
	{
		return ((DWORD) wKey) >> 4;
	}

	struct Node
	{
		WORD  wKey;
		void *pData;
		Node *pNextNode;
	};
	
private:
	Node *m_table[kHashSize];
	Node *m_pBlockAllocated;
	DWORD m_dwBlockCount;

private:
	Node *NewNode(void);
	
public:
	CHashTable(void);
	~CHashTable(void);
		
	void *LookUp(WORD wKey);
	void *Add(WORD wKey, void *pData);
};

#endif
