/*******************************************************************************
 * C H A M E L E O N   ColdFire C file                                         *
 *******************************************************************************
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <rtems.h>
#include <chameleon.h>

#include "MonoSynthPanel.h"
#include "MonoSynthEngine.h"

/******************************************************************************/
#define WORKSPACE_SIZE	256*1024
rtems_unsigned32 rtems_workspace_size = WORKSPACE_SIZE;
rtems_unsigned32 rtems_workspace_start[WORKSPACE_SIZE];
/******************************************************************************/

extern "C" rtems_task rtems_main(rtems_task_argument ignored)
{
	static CMonoSynthPanel panel;
	static CMonoSynthEngine engine;
	
	TRACE("Starting rtems_main\n");
	
	if (!panel.Create(&engine))
		TRACE("ERROR: cannot create a CMonoSynthPanel object in rtems_main\n");
		
	rtems_task_delete(RTEMS_SELF);
}
