/*******************************************************************************
 * C H A M E L E O N                                                           *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/src/examples/MONOSYNTH/menus.cpp                 $
 *     $Date:: 13/05/02 20:11                                                  $
 * $Revision:: 1                                                               $
 *-----------------------------------------------------------------------------*
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#include <rtems.h>

#include "menus.h"

CMenuItem::CMenuItem(void)
{ 
	m_wID = 0xFFFF;
	m_strMenuName = NULL;
	
	m_pItemParent = NULL;
	m_pItemChildFirst = NULL;
	m_pItemChildCurrent = NULL;
	m_pItemPrevious = NULL;
	m_pItemNext = NULL;
}

CMenuItem::CMenuItem(WORD wID, const char *strMenuName)
{
	m_wID = wID;
	m_strMenuName = strMenuName;
	
	m_pItemParent = NULL;
	m_pItemChildFirst = NULL;
	m_pItemChildCurrent = NULL;
	m_pItemPrevious = NULL;
	m_pItemNext = NULL;
}

CMenuItem *CMenuItem::AddSubItem(WORD wID, const char *strMenuName)
{
	ASSERT(this);
	CMenuItem *pItemNew = new CMenuItem(wID, strMenuName);
	
	if (m_pItemChildFirst == NULL)
	{
		m_pItemChildFirst = pItemNew;
		m_pItemChildCurrent = pItemNew;
	}
	else
	{
		CMenuItem *pItem = m_pItemChildFirst;
		
		while (pItem->m_pItemNext)
			pItem = pItem->m_pItemNext;
			
		pItem->m_pItemNext = pItemNew;
		pItemNew->m_pItemPrevious = pItem;
	}
	
	pItemNew->m_pItemParent = this;
	
	return pItemNew;
}

CMenuItem *CMenuItem::AddSubItem(const char *strMenuName)
{
	return AddSubItem(0xFFFF, strMenuName);
}

void CMenuItem::RemoveAll(void)
{
	ASSERT(this);
	CMenuItem *pItemLast, *pItem = m_pItemChildFirst;
		
	while (pItem)
	{
		pItem->RemoveAll();
		pItemLast = pItem;
		pItem = pItem->m_pItemNext;
		delete pItemLast;
	}
	
	m_pItemChildFirst = NULL;
	m_pItemChildCurrent = NULL;
}
