/*******************************************************************************
 * C H A M E L E O N                                                           *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/src/examples/MONOSYNTH/menus.h                   $
 *     $Date:: 13/05/02 20:11                                                  $
 * $Revision:: 1                                                               $
 *-----------------------------------------------------------------------------*
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#ifndef __MENUS_H__
#define __MENUS_H__

#include <chameleon.h>

//////////////////////////////////////////////////////////////////////////////
#define MAKEID(a,b)	((WORD) a << 8) | b)
//////////////////////////////////////////////////////////////////////////////

class CMenuItem
{
private:
	WORD	    m_wID;
	const char *m_strMenuName;
	CMenuItem  *m_pItemParent;
	CMenuItem  *m_pItemChildFirst;
	CMenuItem  *m_pItemChildCurrent;
	CMenuItem  *m_pItemPrevious;
	CMenuItem  *m_pItemNext;

public:
	CMenuItem(void);
	CMenuItem(WORD wID, const char *strMenuName);
	
	WORD GetID(void)
	{
		ASSERT(this);
		return m_wID;
	}
	
	const char *GetMenuName(void)
	{
		ASSERT(this);
		return m_strMenuName ? m_strMenuName : "";
	}
	
	CMenuItem *AddSubItem(WORD wID, const char *strMenuName);
	CMenuItem *AddSubItem(const char *strMenuName);
	void RemoveAll(void);
	
	CMenuItem *GetSelectedItem(void)
	{
		ASSERT(this);
		return m_pItemChildCurrent;
	}
	
	BOOL SelectNextItem(void)
	{
		ASSERT(this);
		if (m_pItemChildCurrent && m_pItemChildCurrent->m_pItemNext)
		{
			m_pItemChildCurrent = m_pItemChildCurrent->m_pItemNext;
			return TRUE;
		}
		return FALSE;
	}
	
	BOOL SelectPrevItem(void)
	{
		ASSERT(this);
		if (m_pItemChildCurrent && m_pItemChildCurrent->m_pItemPrevious)
		{
			m_pItemChildCurrent = m_pItemChildCurrent->m_pItemPrevious;
			return TRUE;
		}
		return FALSE;
	}
};

//////////////////////////////////////////////////////////////////////////////

#endif
