/*******************************************************************************
 * C H A M E L E O N                                                           *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/src/examples/MONOSYNTH/message.h                 $
 *     $Date:: 13/05/02 20:11                                                  $
 * $Revision:: 1                                                               $
 *-----------------------------------------------------------------------------*
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#ifndef __MESSAGE_H__
#define __MESSAGE_H__

#include <rtems.h>
#include <chameleon.h>

//////////////////////////////////////////////////////////////////////////////

struct CMessage
{
	DWORD dwMsg;
	
	virtual const DWORD GetSize(void) = 0;
};

//////////////////////////////////////////////////////////////////////////////

class CMessageHandler
{
private:
	rtems_id m_idQueue;
	int	 m_nMaxMessageSize;

protected:
	BOOL SendMessage(CMessage *pMsg)
	{
		ASSERT(m_idQueue);
		return (rtems_message_queue_send(m_idQueue, pMsg, pMsg->GetSize()) == RTEMS_SUCCESSFUL);
	}

	virtual void OnMessage(CMessage *pMsg) = 0;

public:	
	CMessageHandler(void) { m_idQueue = 0; }
	virtual ~CMessageHandler(void);
	
	void Task(void);
	
	BOOL Create(rtems_name task_name, rtems_task_priority priority, rtems_name queue_name, int nMaxMsgCount, int nMaxMsgSize);
};

//////////////////////////////////////////////////////////////////////////////

#endif