/*******************************************************************************
 * C H A M E L E O N                                                           *
 *******************************************************************************
 *  $Archive:: /Chameleon.sdk/src/examples/MONOSYNTH/panelmodehandler.h        $
 *     $Date:: 13/05/02 20:11                                                  $
 * $Revision:: 1                                                               $
 *-----------------------------------------------------------------------------*
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#ifndef __PANEL_MODE_HANDLER_H__
#define __PANEL_MODE_HANDLER_H__

#include "panel.h"

////////////////////////////////////////////////////////////////////////////////

class CPanelModeHandler
{
protected:
	CPanel *m_pPanel;

protected:
	static char m_strLine0[16+1];
	static char m_strLine1[16+1];

public:
	CPanelModeHandler(void){ m_pPanel = NULL; }

	virtual BOOL Initialize(CPanel *pPanel)
	{
		ASSERT(pPanel);
		m_pPanel = pPanel;
		return TRUE;
	}

	virtual void BeginMode(int nModeBefore) = 0;
	virtual void EndMode(void) = 0;

	virtual void OnPotentiometer(BYTE byPot, BYTE byValue) {}
	virtual void OnEncoder(BYTE byEncoder, char nInc) {}
	virtual void OnKeypad(DWORD dwKeyBits) {}
	virtual void OnTimer(rtems_id idTimer) {}
	virtual void OnParameterChanged(WORD wID) {}
	virtual void OnPresetChanged(BYTE byPreset) {}

	virtual void Display(void) = 0;
};

////////////////////////////////////////////////////////////////////////////////

#endif
